//PONG! 2.0 Multiplayer
//Created by Martijn Kooij.
//Visit www.captaincaveman.nl for more information.
//Version History
//
//version - 1.792 (19-06-2005)
//- Start keeping track of version history.
//- Added connection 'speed' timer in the status bar.
//- Don't do the automatic speed test on startup, cause it's very anoying.
//version - 1.793 (20-06-2005)
//- Check version number on the server.
//version - 1.794 (21-06-2005)
//- Exchange the change of control to the other side before actually chaging control.
//- Removed SpeedTest button.
//- Removed Country selection/filtering.
//- Added an extra margin to upper/lower side of the paddles to avoid doubtfull scores.
//- Extra safety checks to avoid exidental double scores.
//- Extra safety checks to make sure we don't start before we are sure that both players know who scored.
//- Don't allow to start a 1/2 player game from the multiplayer screen.
//- Added 'Go back to the main screen' in the multiplayer screen. Shortcut (Q).
//version - 1.795 (23-06-2005)
//- Implemented ProxyInfo in the socket transport to connect through a proxy (Thanks Joshua Boyce for using one!).
//- Disable filter/options when waiting after create/refresh.
//- Wait for 10s for joined players/available games.
//- Reduced prediction errors a little bit, second attempt at making it less shocky.
//- Fixed the 'Bottom line is shocking when the ball hits it' problem.
//version - 1.8 (29-06-2005)
//- Display Beta and version number in the window title.
//- Added lobby chat.
//- Added in-game chat.
//- Added Direct Play.
//- Added Chat Hotkeys, with settings screen to assign your text to the 5 hotkeys.
//- Added advanced color scheme settings.
//- Added Direct Play Friends list.
//- Automaticly add players of played games to the Direct Play Friends List.
//- Removed speed thingy.
//- Add network.proxy.pong protocol so users might use this to set up their proxy server/connection.
//- Changed version numbering, Multiplayer will be released on 2.0.
//- Bugfix don't start the game on click, if the click is outside the game area.
//- Bugfix in the init of a mp game that made the ball wobble in front of the paddle.
//version - 1.81 (30-06-2005)
//- Pressing enter in the chatfields sends the message.
//- Pressing CTRL+SHIFT+P starts PONG! in Firefox/Mozilla Suite (Just CTRL+P is already taken...)
//- Player 1 (or both in multiplayer) can now also play with the keyboard
//- Bugfix Direct Play status was not reset when the player was not found, causinig further invitations to be blocked.
//version - 1.82 (03-07-2005)
//- Moved all settings to 1 settings screen.
//- When you quit during/after a multiplayer game, you will now be taken to the lobby (instead of the main screen).
//- Set your own prefered shortcut key to start PONG! with.
//- Check for invalid characters in the chat template settings screen.
//- Clear the chatbox on quit.
//- Changed Computer AI a bit.
//- Don't automaticly quit when a game is over.
//- Don't show your own login/logout message.
//- Changed 2 default chat templates.
//- Test: only update data every 100ms instead of every 33ms (to prevent 'blocking up' of the game)
//version - 1.83 (03-07-2005)
//- Wait a little longer after you have sent a Direct Play invitation. 1 min.
//- Made the Exchange Data Interval adjustable, in case of problems...
//- Added a settings tab to add/delete Direct Play friends (modify is not yet implemented).
//- Bugfix: The Win/Loose sounds where wrong in a multiplayer game.
//- Bugfix: You where not notified that the other player quit after a game was over.
//version - 1.84 (06-07-2005)
//- Added smileys to the chat.
//- Changed the PONG! protocol reserved characters (characters a user could not use, [@ ; , :]) into [@ : _ +].
//- Finished the [Direct Play Friends] settings. You can now also modify them.
//- Allow \ in chat.
//- Bugfix: Remove focus from edit after typing an in-game chat msg. (Speed dropped dramaticly cause of this)
//- Bugfix: Sometimes the game tried to write data, when the the connection was already closed. Fixed in WriteData.
//- Bugfix: You where still not always notified that the other player quit after a game was over.
//version - 1.85 (06-07-2005)
//- Added online/offline status info in the Direct Play Friends list (updates every 10s).
//- Added smiley menu.
//- Move a keyboard controled paddle faster.
//- Keyboard shortcut [S] opens the settings screen.
//- Replaced reserved protocol character [:] with [^].
//- Increase keyboard played paddle speed while you hold down the up/down key.
//- Bugfix: You could not insert 2 same smileys in 1 message.
//version - 1.86 (14-07-2005)
//- Connect player 2 player when starting a game. Faster, less bandwidth needed for the server!
//- Added transparent status message window thingy...
//- Removed filtering on refresh games. All games will be returned, exact match will be darker.
//- Init Direct Play when you hit enter in the Direct Play Friends field.
//- Right Mouse Button Pauses/Resumes the game.
//- Wait longer for a connection to the PONG! server, and to the opponent.
//- Close settings screen when you close PONG!
//- Made a bit smaller again.
//- Highlight the [S] for the Settings screen.
//- Bugfix: Don't allow pause when in [Wait to start] mode. It could screw up the game...
//- Bugfix: Reenter selected/typed value in the Direct Play box after update of online/offline status.
//version - 1.87 (16-07-2005)
//- Flash PONG! window when someone comes online (and a setting to disable it...)
//- Added Play On LAN setting, if set PONG! will use your internal IP, so you can play against others on your LAN.
//- Reserved nickname [Captain Caveman] for myself (to be able to convert internal IP to external...)
//- Played a little bit with the Computer AI again...
//- Bugfix: I thought there was PONG! Beta + version in the windows title...
//version - 1.88 (23-07-2005)
//- Miscelanious small changes to make lag less visible (hopefully), and some that might even decrease the lag...
//- Cleaned the UI. (resize, show/hide non relevant buttons).
//- Removed the minimum on the Exchange Data interval.
//- Proces only the last data update (multiple updates come in at once due to the blocking of the socket, nagle).
//- Bugfix: In-game connection was opened as scriptable, instead of binary.
//- Bugfix: Send 'Alive' signal to the server every 1 min. to avoid problem with connections that stay open.
//- Bugfix: better checks for reserved nickname [Captain Caveman]
//- Bugfix: Init in-game client (opponent socket) on first accept of local server (fixes connection timing problem).
//version - 1.89 (26-07-2005)
//- Added a blocking socket to send crucial data to the other player.
//- Added a help tooltip on all (except for the settings screen...) items in PONG! (Damn that is a boring job...)
//- Give a color to each player in the chat boxes.
//- Sort Direct Play Friends list on save.
//- Set focus on chat edit after sending a message so you can keep on typing... Only in the lobby chat.
//- Removed the adjustable exchange data interval (If all goes well, we wont need it anymore.)
//- Correct faulty ball positions only 3 times per player 2 player route. Might make them more obvious.
//- Added some extra margin between chatlines if the is no smiley in the msg. Only in the lobby chat.
//- Bugfix: When none of your Direct Play Friends was online, they did not get the (offline) status.
//- Bugfix: When "Play on LAN" was checked at startup, the server did not receive this. Send ip on startup now.
//version 1.9 (28-07-2005)
//- More tweaks to make lag less visible. Including ELRS (Extreme Lag Recovery System)...
//- Setting to disable the use of help tooltips.
//- Added a lag alert message if your lag time has been more then 400ms for 3x.
//- Switch the single player AI on and off at random intervals of max. 10 sec. if your 3 points ahead.
//- Some small UI fixes.
//- Send a lobby chat message when you start a game against someone (so the rest knows you 2 are gone).
//- Bugfix: Don't flash the PONG! window when you log in...
//- Bugfix: If your opponent waited long with accepting your quit msg, you would receive an extra empty one...
//- Bugfix: Close any status messages on Quit of game.
//version 1.91 (30-07-2005)
//- Show all online (and available) players.
//- Just 1 multiplayer button [Play], no more create/refresh/join.
//- Ask the user if he wants to add a toolbarbutton after installing PONG!.
//- Bugfix: There were still very small (test) buffers on both socket's outputstreams.
//version 1.92 (03-08-2005)
//- Tweaked the ELRS again... Better but not good.
//- Removed the color scheme selector from the main screen.
//- Prevent a user from sending [login/logout/plays against] system messages in the chat.
//- Bugfix: MP, On the left side the ball bounced too soon, on the right too late.
//- Bugfix: Sometimes empty online player items would show up after a game.
//- Bugfix: Window flashed when someone logged out, instead of in...
//- Bugfix: Refresh window after adding the toolbar button on the first run. Fixes Ff getting screwed up...
//- Bugfix: You could start Multiplayer while playing a singleplayer game, this screwed up the display.
//version 1.99 (07-08-2005)
//- Use 2 ports per player now (still 10997 and 10998) in stead of P1 10997 and P2 10998
//- Don't allow 2 PONG! windows to open anymore.
//- More tweaks on the ELRS, it will also only kick in if your ping time is over 125ms
//- Lag alert will show up at a ping of 300ms instead of 400ms.
//- Ask a nickname from the user before first connect.
//- Bugfix: Prevent pressing Pause when not playing a game.
//- Bugfix: After a failed connection the Online players box was sometimes empty.
//version 2.0 (13-08-2005)
//- Final UI cleanup, and nothing more than that... Release it, ans start praying...
//version 2.1 (18-08-2005)
//- Added customizable keyboard keys for the game.
//- Replaced the blocking socket connection with a non-blocking one. Did not make too much difference anyway.
//- Allow more time for players to connect to each other, 10 sec. instead of 5.
//- Added forum address to all info/waring messages.
//- Made some changes (again) to the computer AI.
//- Bugfix: Don't allow pause game after a game has finished.
//- Bugfix: "Add toolbar" question sometimes kept on poping up. Made the add toolbar mechanism more decent.
//- Bugfix: Check for duplicates in the online players box.
//- Bugfix: Rightclick did still show "Paused" in Main screen and Lobby.
//- Bugfix: On first open of the MP lobby, you could enter a very long nickname instead of max. 20 chars.
//- Bugfix: Added some extra resets on opening of an MP game to prevent it from not starting the actual game.
//version 2.11 (22-08-2005)
//- Bugfix: Typo confusion with on of my other extensions, which screwed up the automatic toolbar adding function...
//version 2.15 (25-10-2005)
//- Finally compatible with Firefox 1.5 beta2 builds.
//- Added/tested compatibility with Thunderbird.
//- Fixed styles so everyting is usable under extreme themes (Noia/Charamel/Etc.)
//- Bugfix: Forgot to check the nickname for invalid charatcers on the first startup.
//version 2.16 (03-11-2005)
//- Tested for compatibility with Firefox 1.5 RC1
//version 2.2 (31-01-2006)
//- Added Super Insane speed setting.
//- Added animated toolbar button.
//- Added extra checks to prevent duplicate online players showing in the list.
//- Added Option to turn off keyboard acceleration (paddle speed increase the longer you press up/down)
//- Made it randomly possible to score an ace.
//- Bugfix: Pause by key and Pause by losing focus got mixed up, thanks zeppelin.
//- Bugfix: Fixed the customize toolbar icon.
//version 2.2.1 (14-04-2006)
//- Made the main windows position persistent.
//- Made the game ports adjustable.
//- Removed a debug message that accidentaly was still in here.
//- Bugfix: Multiplayer games with speedsetting Super Insane did not work at all.
//version 2.2.2 (16-5-2007)
//- Changed the multiplayer hostname to point to my desktop (pong.captaincaveman.nl)
//- Changed the displayed forum links to forum.captaincaveman.nl
//version 2.2.3 (20-5-2007)
//- Fixed memory leak.
//- Changed the server offline message.
//version 2.2.4 (23-5-2007)
//- Added settings to adjust the server hostname and port number.
//version 2.2.5 (08-5-2008)
//- Tested on Firefox 3 RC1
//- Bugfix: Pause by right mouse click resumed the game after finishing it.
//version 2.2.6 (18-12-2008)
//- Tested on Firefox 3.1 Beta2
//- Lots of bugfixes for Seamonkey
//version 2.3 (30-01-2009)
//- Rewrote Multiplayer Lobby, server is now a normal web application, client connect trough HTTPRequests.

const WINDOW_TOP = 18;
const WINDOW_BOTTOM = 330;
const WINDOW_LEFT = 10;
const WINDOW_CENTER = 189;
const WINDOW_RIGHT = 370;

const SEP_COMMANDS = '@'; //Used between multiple commands.
const SEP_COMMAND  = '^'; //Used Between command^message.
const SEP_MESSAGES = '_'; //Used internally between messages.
const SEP_MESSAGE  = '+'; //Used internally in 1 message.

const SELECT_ALL = 'ALL';

const MSG_LOGIN = "*Logged in...*";
const MSG_LOGOUT = "*Logged out...*";
const MSG_PLAYSAGAINST = "*Plays against";

const EXCHANGE_DATA_SPEED = 25;//100;  //25
const LAG_TIME_ALERT = 300;//500; //300
const ELRS_TIME = 100;//400; //100

var oPongTimedGameClient = null;
var oPongLoopGameClient = null;
var oPongIncomingNBGameClient = null;
var oPongIncomingBGameClient = null;
var oPongIncomingTimedGameClient = null;
var oPongIncomingLoopGameClient = null;
var oTimedServerSocket = null;
var oLoopServerSocket = null;

var iTimedPort = 10997;
var iLoopPort = 10998;

var iPONGHTTPConnection = 0;

var ServerSocketListener =
{
    iTimedPort: 0,
    
	onSocketAccepted : function(socket, transport)
	{
		if (socket.port == this.iTimedPort || socket.port == 10995)
		{
			oPongIncomingTimedGameClient = new Socket;
			if (oPongIncomingTimedGameClient)
			{
				oPongIncomingTimedGameClient.create(transport);
				oPongIncomingTimedGameClient.async(oPongClientObserver);
			}
		}
		else
		{
			oPongIncomingLoopGameClient = new Socket;
			if (oPongIncomingLoopGameClient)
			{
				oPongIncomingLoopGameClient.create(transport);
				oPongIncomingLoopGameClient.async(oPongClientObserver);
			}
		}
	},
	onStopListening : function(socket, status){}
};

var oPongClientObserver =
{
	streamStarted: function(socketContext)
	{
		//PongClient Start action.
	},
	streamStopped: function(socketContext, status)
	{
		//PongClient Stop action.
	},
	receiveData: function(data)
	{
		//PongClient Receive data action.
		ProcessReceivedPONGData(data);
	}
};

var settingsObserver =
{
	observe: function(subject, topic, state)
	{
		if (topic == "apply-colorscheme" && state == 'OK') if (this) subject.UpdateColorScheme();
		if (topic == "apply-chattemplate" && state == 'OK') if (this) subject.SetChatTemplateTooltips();
		if (topic == "apply-sound" && state == 'OK') if (this) subject.SwitchSound();
		if (topic == "apply-keyboardaccel" && state == 'OK') if (this) subject.SwitchKeyboardAcceleration();
		if (topic == "apply-attention" && state == 'OK') if (this) subject.SwitchAttention();
		if (topic == "apply-playonlan" && state == 'OK') if (this) subject.SwitchPlayonLAN();
		if (topic == "apply-keyboardmovekeys" && state == 'OK') if (this) subject.SetKeyboardMoveKeys();
		if (topic == "apply-displaytooltips" && state == 'OK') if (this) subject.SwitchDisplayTooltips();
		if (topic == "apply-directplayfriends" && state == 'OK') if (this) subject.LoadDirectPlayFriends();
		if (topic == "apply-ports" && state == 'OK') if (this) subject.SwitchPorts();
	}
}

var oBall = null;
var oComputer= null;
var oPlayer= null;
var oLine = null;
var oComputerScore = null;
var oPlayerScore = null;
var oGameTime = null;
var oSoundHitPlayerBatt = null;
var oSoundHitComputerBatt = null;
var oSoundHitWall = null;
var oSoundScore = null;
var oSoundMiss = null;
var oSoundWinGame = null;
var oSoundLooseGame = null;
var oStatusMessage = null;

var aPastPositions = null;
var aDirectPlayFriends = new Array;
var aSmileys = new Array(["O:-)", "s14"],[":-)", "s1"],[":-(", "s2"],[";-)", "s3"],[":-P", "s4"],[":-D", "s5"],[":-[", "s6"],[":-\\", "s7"],["=-O", "s8"],[":-*", "s9"],[">:o", "s10"],["8-)", "s11"],[":-$", "s12"],[":-!", "s13"],[":'(", "s15"],[":-X", "s16"],[":)", "s1"],[":(", "s2"],[";)", "s3"],[":P", "s4"],[":D", "s5"],[":$", "s6"],["*-)", "s7"],[":-O", "s8"],["(K)", "s9"],["8o|", "s10"],["(H)", "s11"],["(A)", "s14"],[":-#", "s16"]);

var TimerID = null;
var IntervalID = null;
var ExchangeDataID = null;

var PONG_VERSION = "";
var sSpeedCode = "";
var sBestOfCode = "";
var sPlayerID = "";
var sExternalIPAddress = "";
var sNickName = "";
var sStatus = "W";
var sOpponentID = "";
var sOpponentNickName = "";
var sOpponentIPAddress = "";
var sOpponentStatus = "W";
var sWhoScored = "";
var sChatStatus = 'N';
var sCurrentColorScheme = 'default';
var sCurrentSizeMode = "default";
var sDirectPlayInvitation = '';
var sLastSelectedPlayerLIID = "";

var iOpponentYPos = 200;
var iMPBallXPos = 200;
var iMPBallYPos = 200;
var iMPBallVX = -8;
var iMPBallVY = -8;
var iGameTime = 0;
var iMouseX = 0;
var iMouseY = 0;
var iBallVX = -8;
var iBallVY = -8;
var iAIVY = 8;
var iBattHeight = 0;
var iPlayerScore = 0;
var iComputerScore = 0;
var iBestOf = 10;
var iSpeed = 1;
var iTicksSinceLastSound = 0;
var iKeyboardMoveSpeed = 5;
var iKeyDownTicks = 0;
var iAIHighBalls = 0;
var iAILowBalls = 0;
var iLastMPRead = 0;
var iLagTime = 0;
var iLagAlertCount = 0;
var iConnectionTestResult = 0;
var iTicksSinceSendControl = 0;
var iP1KeyUp = 38;
var iP1KeyDown = 40;
var iP1KeyStart = 32;
var iP2KeyUp = 65;
var iP2KeyDown = 90;
var iP2KeyStart = 32;

var bPaused = false;
var bTwoPlayerGame = false;
var bAIOn = false;
var bPlayer1UpKeyDown = false;
var bPlayer1DownKeyDown = false;
var bPlayer2UpKeyDown = false;
var bPlayer2DownKeyDown = false;
var bPlayer2Starts = false;
var bJustStartedSet = true;
var bWaitToStart = true;
var bSoundOn = true;
var bKeyboardAccelerationOn = true;
var bMultiPlayer = false;
var bTyping = false;
var bPreferencesLoaded = false;
var bStartedGame = false;
var bControlsGame = false;
var bExchangeData = true;
var bTickCompleted = true;
var bPlayerCanResumeGame = true;
var bDataIsCurrent = true;
var bQuiting = false;
var bHandledScore = true;
var bPlaysWithKeyboard = false;
var bReturnToLobby = false;
var bSmileyPopupIsShowing = false;
var bInGameConnected = false;
var bNonBlockingConnected = false;
var bBlockingConnected = false;
var bAttentionOnLogin = true;
var bPlayOnLAN = false;
var bDisplayTooltips = true;
var bAllowReservedNick = false;
var bIsTestGame = false;
var bGameFinished = false;

//Init key handler.
document.addEventListener("keydown",  ProcessKeyDown, true);
document.addEventListener("keyup", ProcessKeyUp, true);

//Init mouse handler.
document.addEventListener("mousemove", ProcessMouse, true);
document.addEventListener("mousedown", ProcessMouseDown, true);

window.addEventListener('unload', ClosePONG, true);

function InitWindow()
{
	include('chrome://pong/content/jslib/sound.js');
	include('chrome://pong/content/jslib/socket.js');

	oSoundHitPlayerBatt = new Sound('chrome://pong/content/hitplayerbatt.wav');
	oSoundHitComputerBatt = new Sound('chrome://pong/content/hitcomputerbatt.wav');
	oSoundHitWall = new Sound('chrome://pong/content/hitwall.wav');
	oSoundScore = new Sound('chrome://pong/content/score.wav');
	oSoundMiss = new Sound('chrome://pong/content/miss.wav');
	oSoundWinGame = new Sound('chrome://pong/content/wingame.wav');
	oSoundLooseGame = new Sound('chrome://pong/content/loosegame.wav');

	oStatusMessage = GetStatusMessage();

	ResizePONG('default');

	PONG_VERSION = GetVersion();
	document.getElementById('pong-window').setAttribute('title', 'PONG! ' + PONG_VERSION + ' Multiplayer');

	oBall = document.getElementById('ball');
	oComputer= document.getElementById('computer');
	oPlayer= document.getElementById('player');
	oLine = document.getElementById('line');
	oComputerScore = document.getElementById('computer_score');
	oPlayerScore = document.getElementById('player_score');
	oGameTime = document.getElementById('addictlevel');

	iBattHeight = parseInt(oPlayer.height);

	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.addObserver(settingsObserver, "apply-colorscheme", false);
	oObService.addObserver(settingsObserver, "apply-chattemplate", false);
	oObService.addObserver(settingsObserver, "apply-sound", false);
	oObService.addObserver(settingsObserver, "apply-keyboardaccel", false);
	oObService.addObserver(settingsObserver, "apply-attention", false);
	oObService.addObserver(settingsObserver, "apply-playonlan", false);
	oObService.addObserver(settingsObserver, "apply-keyboardmovekeys", false);
	oObService.addObserver(settingsObserver, "apply-displaytooltips", false);
	oObService.addObserver(settingsObserver, "apply-directplayfriends", false);
	oObService.addObserver(settingsObserver, "apply-ports", false);

	InitStart();
}

function ClosePONG()
{
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	oObService.notifyObservers(this, "pong-close", "OK");
	
	oObService.removeObserver(settingsObserver, "apply-colorscheme"); 
	oObService.removeObserver(settingsObserver, "apply-chattemplate"); 
	oObService.removeObserver(settingsObserver, "apply-sound"); 
	oObService.removeObserver(settingsObserver, "apply-keyboardaccel"); 
	oObService.removeObserver(settingsObserver, "apply-attention"); 
	oObService.removeObserver(settingsObserver, "apply-playonlan"); 
	oObService.removeObserver(settingsObserver, "apply-keyboardmovekeys"); 
	oObService.removeObserver(settingsObserver, "apply-displaytooltips"); 
	oObService.removeObserver(settingsObserver, "apply-directplayfriends"); 
	oObService.removeObserver(settingsObserver, "apply-ports"); 

	settingsObserver = null;
}

function InitStart()
{
	//Reset and prepare all.
	clearTimeout(TimerID);
	TimerID = null;

	if (iGameTime > 0) SetPreferenceInt("gametime", iGameTime);
	clearInterval(IntervalID);
	IntervalID = null;

	iBallVX = -8;
	iBallVY = 8;
	iAIVY = 8;

	iPlayerScore = 0;
	iComputerScore = 0;

	aPastPositions = null;

	sLastSelectedPlayerLIID = "";

	iOpponentYPos = 200;
	iMPBallXPos = 200;
	iMPBallYPos = 200;
	iMPBallVX = -8;
	iMPBallVY = -8;
	iTicksSinceLastSound = 0;
	iTicksSinceSendControl = 0;
	iAIHighBalls = 0;
	iAILowBalls = 0;

	bPaused = false;
	bTwoPlayerGame = false;
	bAIOn = false;
	bPlayer1UpKeyDown = false;
	bPlayer1DownKeyDown = false;
	bPlayer2UpKeyDown = false;
	bPlayer2DownKeyDown = false;
	bPlayer2Starts = false;
	bJustStartedSet = true;
	bWaitToStart = true;
	bQuiting = false;
	bTickCompleted = true;
	bExchangeData = true;
	bPlayerCanResumeGame = true;
	bDataIsCurrent = true;
    bHandledScore = true;
	bPlaysWithKeyboard = false;
	bSmileyPopupIsShowing = false;
	bGameFinished = false;

	document.getElementById('instructions').style.display = "block";
	document.getElementById('pongsettings').style.display = "block";
	document.getElementById('speedselect').style.display = "block";
	document.getElementById('bestofselect').style.display = "block";

	document.getElementById('multiplayer').style.display = "none";

	oBall.style.display = "none";
	oComputer.style.display = "none";
	oPlayer.style.display = "none";
	oComputerScore.style.display = "none";
	oPlayerScore.style.display = "none";
	document.getElementById('label_computer').style.display = "none";
	document.getElementById('label_player').style.display = "none";

	document.getElementById('line').style.display = "none";
	document.getElementById('statusinfo').style.display = "none";
	document.getElementById('vbgamechat').style.display = "none";

	oBall.left = 200;
	oBall.top = 200;
	oComputer.left = 7;
	oComputer.top = 200;
	oPlayer.left = 365;
	oPlayer.top = 200;

	oComputerScore.value = iComputerScore;
	oPlayerScore.value = iPlayerScore;

	if (bPreferencesLoaded == false)
	{
		InitPONGPreferences();

		//Check defaults.
		if (!CheckPreferenceUserValue("gametime")) SetPreferenceInt("gametime", 0);
		iGameTime = GetPreferenceInt("gametime");
		UpdateAddictLevel();

		if (!CheckPreferenceUserValue("colorscheme")) SetPreferenceString("colorscheme", "default");
		if (!CheckPreferenceUserValue("speed")) SetPreferenceString("speed", "normal");
		if (!CheckPreferenceUserValue("bestof")) SetPreferenceString("bestof", "b10");
		if (!CheckPreferenceUserValue("nickname")) SetPreferenceString("nickname", "");
		if (!CheckPreferenceUserValue("soundon")) SetPreferenceBool("soundon", true);
		if (!CheckPreferenceUserValue("keyboardacceleration")) SetPreferenceBool("keyboardacceleration", true);
		if (!CheckPreferenceUserValue("directplayfriends")) SetPreferenceString("directplayfriends", "");
		if (!CheckPreferenceUserValue("attentiononlogin")) SetPreferenceBool("attentiononlogin", true);
		if (!CheckPreferenceUserValue("playonlan")) SetPreferenceBool("playonlan", false);
		if (!CheckPreferenceUserValue("displaytooltips")) SetPreferenceBool("displaytooltips", true);

		//Chat templates.
		if (!CheckPreferenceUserValue("chattemplate5")) SetPreferenceString("chattemplate5", "Game on!");
		if (!CheckPreferenceUserValue("chattemplate6")) SetPreferenceString("chattemplate6", "n00b...");
		if (!CheckPreferenceUserValue("chattemplate7")) SetPreferenceString("chattemplate7", "The sun got in my eyes!");
		if (!CheckPreferenceUserValue("chattemplate8")) SetPreferenceString("chattemplate8", "Enjoy!");
		if (!CheckPreferenceUserValue("chattemplate9")) SetPreferenceString("chattemplate9", "Ownd!");

		//New color scheme preferences...
		if (!CheckPreferenceUserValue("colorschemetextdefaultred")) SetPreferenceInt("colorschemetextdefaultred", 255);
		if (!CheckPreferenceUserValue("colorschemetextdefaultgreen")) SetPreferenceInt("colorschemetextdefaultgreen", 255);
		if (!CheckPreferenceUserValue("colorschemetextdefaultblue")) SetPreferenceInt("colorschemetextdefaultblue", 255);
		if (!CheckPreferenceUserValue("colorschemebackdefaultred")) SetPreferenceInt("colorschemebackdefaultred", 0);
		if (!CheckPreferenceUserValue("colorschemebackdefaultgreen")) SetPreferenceInt("colorschemebackdefaultgreen", 0);
		if (!CheckPreferenceUserValue("colorschemebackdefaultblue")) SetPreferenceInt("colorschemebackdefaultblue", 0);
		if (!CheckPreferenceUserValue("colorschemeobjectsdefault")) SetPreferenceString("colorschemeobjectsdefault", "default");

		if (!CheckPreferenceUserValue("colorschemetext1red")) SetPreferenceInt("colorschemetext1red", 255);
		if (!CheckPreferenceUserValue("colorschemetext1green")) SetPreferenceInt("colorschemetext1green", 64);
		if (!CheckPreferenceUserValue("colorschemetext1blue")) SetPreferenceInt("colorschemetext1blue", 64);
		if (!CheckPreferenceUserValue("colorschemeback1red")) SetPreferenceInt("colorschemeback1red", 10);
		if (!CheckPreferenceUserValue("colorschemeback1green")) SetPreferenceInt("colorschemeback1green", 50);
		if (!CheckPreferenceUserValue("colorschemeback1blue")) SetPreferenceInt("colorschemeback1blue", 110);
		if (!CheckPreferenceUserValue("colorschemeobjects1")) SetPreferenceString("colorschemeobjects1", "red");

		if (!CheckPreferenceUserValue("colorschemetext2red")) SetPreferenceInt("colorschemetext2red", 9);
		if (!CheckPreferenceUserValue("colorschemetext2green")) SetPreferenceInt("colorschemetext2green", 189);
		if (!CheckPreferenceUserValue("colorschemetext2blue")) SetPreferenceInt("colorschemetext2blue", 9);
		if (!CheckPreferenceUserValue("colorschemeback2red")) SetPreferenceInt("colorschemeback2red", 170);
		if (!CheckPreferenceUserValue("colorschemeback2green")) SetPreferenceInt("colorschemeback2green", 50);
		if (!CheckPreferenceUserValue("colorschemeback2blue")) SetPreferenceInt("colorschemeback2blue", 10);
		if (!CheckPreferenceUserValue("colorschemeobjects2")) SetPreferenceString("colorschemeobjects2", "green");

		if (!CheckPreferenceUserValue("colorschemetext3red")) SetPreferenceInt("colorschemetext3red", 64);
		if (!CheckPreferenceUserValue("colorschemetext3green")) SetPreferenceInt("colorschemetext3green", 64);
		if (!CheckPreferenceUserValue("colorschemetext3blue")) SetPreferenceInt("colorschemetext3blue", 255);
		if (!CheckPreferenceUserValue("colorschemeback3red")) SetPreferenceInt("colorschemeback3red", 10);
		if (!CheckPreferenceUserValue("colorschemeback3green")) SetPreferenceInt("colorschemeback3green", 60);
		if (!CheckPreferenceUserValue("colorschemeback3blue")) SetPreferenceInt("colorschemeback3blue", 10);
		if (!CheckPreferenceUserValue("colorschemeobjects3")) SetPreferenceString("colorschemeobjects3", "blue");

		if (!CheckPreferenceUserValue("player1keyup")) SetPreferenceInt("player1keyup", 38);
		if (!CheckPreferenceUserValue("player1keydown")) SetPreferenceInt("player1keydown", 40);
		if (!CheckPreferenceUserValue("player1keystart")) SetPreferenceInt("player1keystart", 32);
		if (!CheckPreferenceUserValue("player2keyup")) SetPreferenceInt("player2keyup", 65);
		if (!CheckPreferenceUserValue("player2keydown")) SetPreferenceInt("player2keydown", 90);
		if (!CheckPreferenceUserValue("player2keystart")) SetPreferenceInt("player2keystart", 32);
		
		if (!CheckPreferenceUserValue("timedport")) SetPreferenceInt("timedport", 10997);
		if (!CheckPreferenceUserValue("loopport")) SetPreferenceInt("loopport", 10998);

		//Not sure if this helps setting up for a proxy server
		var oNetworkPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		oNetworkPreferences = oNetworkPreferences.getBranch('network.proxy.');
		if (!oNetworkPreferences.prefHasUserValue("pong")) oNetworkPreferences.setCharPref('pong', oNetworkPreferences.getCharPref('http'));
		if (!oNetworkPreferences.prefHasUserValue("pong_port")) oNetworkPreferences.setIntPref('pong_port', oNetworkPreferences.getIntPref('http_port'));

		//Load preference.
    	InitPreferences();

		bPreferencesLoaded = true;
	}
}

function OpenSettings()
{
	window.open("chrome://pong/content/pongsettings.xul", "pong-settings", "centerscreen,chrome,width=600,height=395");
}

function SetChatTemplateTooltips()
{
	document.getElementById('lbkey5').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate5"));
	document.getElementById('lbkey6').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate6"));
	document.getElementById('lbkey7').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate7"));
	document.getElementById('lbkey8').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate8"));
	document.getElementById('lbkey9').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate9"));

	document.getElementById('lbgkey5').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate5"));
	document.getElementById('lbgkey6').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate6"));
	document.getElementById('lbgkey7').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate7"));
	document.getElementById('lbgkey8').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate8"));
	document.getElementById('lbgkey9').setAttribute('tooltiptext', 'Send: ' + GetPreferenceString("chattemplate9"));
}

function UpdateColorScheme()
{
	var sID = GetPreferenceString("colorscheme");
	ProcessColorSelect(sID);
}

function InitPreferences()
{
	//Color scheme.
	UpdateColorScheme();

	//Sound effects.
	bSoundOn = GetPreferenceBool("soundon");
	
	//Keyboard acceleration (speed increase after longer pressing up or down...)
	bKeyboardAccelerationOn = GetPreferenceBool("keyboardacceleration");

	//Speed level.
	var oMLSpeed = document.getElementById('mlspeedselect');
	var oMLMPSpeed = document.getElementById('mlmpspeedselect');
	var sIDSpeed = GetPreferenceString("speed");
	var oMItemSpeed = document.getElementById(sIDSpeed);
	var oMMPItemSpeed = document.getElementById('mp' + sIDSpeed);

	oMLSpeed.selectedItem = oMItemSpeed;
	oMLMPSpeed.selectedItem = oMMPItemSpeed;
	ProcessSpeedSelect(sIDSpeed);

	//Best of.
	var oMLBestOf = document.getElementById('mlbestofselect');
	var oMLMPBestOf = document.getElementById('mlmpbestofselect');
	var sIDBestOf = GetPreferenceString("bestof");
	var oMItemBestOf = document.getElementById(sIDBestOf);
	var oMMPItemBestOf = document.getElementById('mp' + sIDBestOf);

	oMLBestOf.selectedItem = oMItemBestOf;
	oMLMPBestOf.selectedItem = oMMPItemBestOf;
	ProcessBestOfSelect(sIDBestOf);

	//NickName.
	sNickName = GetPreferenceString("nickname");

	if (CheckPreferenceUserValue("allowreservednickname")) bAllowReservedNick = GetPreferenceBool("allowreservednickname");
	if (sNickName.toLowerCase().indexOf('captain') >= 0 && sNickName.toLowerCase().indexOf('caveman') >= 0 && bAllowReservedNick == false)
	{
		MessageBox('I am sorry, but I had to reserve this nickname for myself for technical reasons.\nPlease enter a different nickname.');
		sNickName = "";
		SetPreferenceString("nickname", sNickName);
	}
	document.getElementById('tbnickname').value = sNickName;

	//Chat templates.
	SetChatTemplateTooltips();

	//Direct Play Friends.
	LoadDirectPlayFriends();

	//Draw attention when someone logs in.
	bAttentionOnLogin = GetPreferenceBool("attentiononlogin");

	//Play On LAN
	bPlayOnLAN = GetPreferenceBool("playonlan");

	//Connection Ports.
	SwitchPorts(true);

	//Tooltips.
	SwitchDisplayTooltips();

	//Keyboard movement keys.
	SetKeyboardMoveKeys();
}

function LoadDirectPlayFriends()
{
	var sFriends = GetPreferenceString("directplayfriends");
	var aFriends, aFriend;
	var iIndex, iLen;

	ClearDirectPlayFriends();

	if (sFriends != '')
	{
		aFriends = sFriends.split(SEP_MESSAGES);
		iLen = aFriends.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			aFriend = aFriends[iIndex].split(SEP_MESSAGE);
			AddDirectPlayFriend(aFriend[0], aFriend[1]);
		}
	}
	ApplyColorScheme(document.getElementById('mlmpdirectplayselect'));
}

function ClearDirectPlayFriends()
{
    aDirectPlayFriends = null;
	aDirectPlayFriends = new Array;

	RemoveAllChildren(document.getElementById('mlmpdirectplayselect'));
}

function AddDirectPlayFriend(sIPAddress, sNickName)
{
	var oMenu = document.getElementById('mlmpdirectplayselect');
	var iLen = aDirectPlayFriends.length;
	var iIndex;
	var bFound = false;

	//Check for duplicates.
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (aDirectPlayFriends[iIndex][0] == sIPAddress && aDirectPlayFriends[iIndex][1] == sNickName) bFound = true;
	}
	if (bFound == false)
	{
		aDirectPlayFriends[iLen] = new Array(sIPAddress, sNickName);
		var oMItem = oMenu.insertItemAt(iLen, sNickName + ' - ' + sIPAddress + ' (offline)', sIPAddress + SEP_MESSAGES + sNickName)
		oMItem.style.fontWeight = "bold";
	}
}

function SaveDirectPlayFriends()
{
	var sFriends = "";
	var iIndex, iLen;

	aDirectPlayFriends.sort(SortNickNames);
	iLen = aDirectPlayFriends.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (aDirectPlayFriends[iIndex][0] != '')
		{
			sFriends += aDirectPlayFriends[iIndex][0] + SEP_MESSAGE + aDirectPlayFriends[iIndex][1] + SEP_MESSAGES;
		}
	}
	sFriends = sFriends.substring(0, sFriends.length - 1); //Remove last SEP_MESSAGES
	SetPreferenceString("directplayfriends", sFriends);
}

function ApplyColorScheme(parentObject)
{
	var oChild;
	var iIndex, iLen;

	iLen = parentObject.childNodes.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oChild = parentObject.childNodes[iIndex];

		if (oChild.nodeName == 'menulist' || oChild.nodeName == 'checkbox' || oChild.nodeName == 'textbox' || (oChild.nodeName == 'groupbox' && oChild.className != 'lobbychat' && oChild.className != 'gamechat') || oChild.nodeName == 'menupopup' || (oChild.nodeName == 'menuitem' && oChild.id != 'smile') || oChild.nodeName == 'button' || oChild.nodeName == 'listhead' || oChild.nodeName == 'listheader')
		{
			oChild.style.backgroundColor = "rgb(" + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "blue") + ")";
			oChild.style.color = "rgb(" + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "blue") + ")";
		}
		if (oChild.childNodes && oChild.childNodes.length > 0) ApplyColorScheme(oChild);
	}
}

function ProcessColorSelect(sID)
{
	var oWindow = document.getElementById('pong-window');

	oWindow.className = 'main_' + sID;

	if (sID == 'default') sCurrentColorScheme = 'default';
	if (sID == 'red') sCurrentColorScheme = '1';
	if (sID == 'green') sCurrentColorScheme = '2';
	if (sID == 'blue') sCurrentColorScheme = '3';

	//Apply colors to all
	oWindow.style.backgroundColor = "rgb(" + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "blue") + ")";
	oWindow.style.color = "rgb(" + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "blue") + ")";
	document.getElementById('stack_main').borderColor = "rgb(" + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "blue") + ")";

	ApplyColorScheme(document.getElementById('pong-window'));
	//Special items.
	oBall.className = GetPreferenceString('colorschemeobjects' + sCurrentColorScheme);
	oComputer.className = GetPreferenceString('colorschemeobjects' + sCurrentColorScheme);
	oPlayer.className = GetPreferenceString('colorschemeobjects' + sCurrentColorScheme);
	oLine.className = GetPreferenceString('colorschemeobjects' + sCurrentColorScheme);

	//Save it.
	SetPreferenceString("colorscheme", sID);
	oWindow.focus();
}

function SwitchSound()
{
	bSoundOn = GetPreferenceBool("soundon");
}

function SwitchKeyboardAcceleration()
{
	bKeyboardAccelerationOn = GetPreferenceBool("keyboardacceleration");
}

function SwitchAttention()
{
	bAttentionOnLogin = GetPreferenceBool("attentiononlogin");
}

function SwitchPlayonLAN()
{
	bPlayOnLAN = GetPreferenceBool("playonlan");
	SendIPAddress();
}

function SetKeyboardMoveKeys()
{
	iP1KeyUp = GetPreferenceInt("player1keyup");
	iP1KeyDown = GetPreferenceInt("player1keydown");
	iP1KeyStart = GetPreferenceInt("player1keystart");
	iP2KeyUp = GetPreferenceInt("player2keyup");
	iP2KeyDown = GetPreferenceInt("player2keydown");
	iP2KeyStart = GetPreferenceInt("player2keystart");
}

function SwitchPorts(bNoTest)
{
	//InGame ports
	iTimedPort = GetPreferenceInt("timedport");
	iLoopPort = GetPreferenceInt("loopport");
}

function SwitchDisplayTooltips()
{
	bDisplayTooltips = GetPreferenceBool("displaytooltips");
	InitTooltips(document.getElementById('pong-window'));
	
	var oPortReminder = document.getElementById('portreminder');
	var sValue = oPortReminder.firstChild.nodeValue.replace('10997', iTimedPort);
	sValue = oPortReminder.firstChild.nodeValue.replace('10998', iLoopPort);
	oPortReminder.firstChild.nodeValue = sValue;
}

function InitTooltips(parentObject)
{
	var oChild;
	var sTooltip = "";
	var iIndex, iLen;

	iLen = parentObject.childNodes.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oChild = parentObject.childNodes[iIndex];
		if (oChild.toString().toLowerCase() == '[object xulelement]' && oChild.hasAttribute('tooltip') == true)
		{
			sTooltip = oChild.getAttribute('tooltip');
			if (sTooltip && sTooltip != "")
			{
				if (sTooltip.substr(0, 3) == "no_" && bDisplayTooltips == true)
				{
					sTooltip = sTooltip.substring(3, sTooltip.length);
				}
				if (sTooltip.substr(0, 3) != "no_" && bDisplayTooltips == false)
				{
					sTooltip = 'no_' + sTooltip;
				}
				oChild.setAttribute('tooltip', sTooltip);
			}
		}
		if (oChild.childNodes && oChild.childNodes.length > 0) InitTooltips(oChild);
	}
}

function ProcessSpeedSelect(sLevel)
{
	sSpeedCode = sLevel;
	iSpeed = 1;
	if (sSpeedCode == "medium") iSpeed = 2;
	if (sSpeedCode == "fast") iSpeed = 3;
	if (sSpeedCode == "insane") iSpeed = 4;
	if (sSpeedCode == "superinsane") iSpeed = 5;
	//Save it.
	SetPreferenceString("speed", sSpeedCode);

	//Sync Single/Multi player UI...
	var oMLSpeed = document.getElementById('mlspeedselect');
	var oMLMPSpeed = document.getElementById('mlmpspeedselect');
	var oMItemSpeed = document.getElementById(sSpeedCode);
	var oMMPItemSpeed = document.getElementById('mp' + sSpeedCode);
	oMLSpeed.selectedItem = oMItemSpeed;
	oMLMPSpeed.selectedItem = oMMPItemSpeed;

	document.getElementById('pong-window').focus();
}

function ProcessBestOfSelect(sID)
{
	sBestOfCode = sID.toString();
	iBestOf = sBestOfCode.substr(1, sBestOfCode.length);
	//Save it.
	SetPreferenceString("bestof", sBestOfCode);

	//Sync Single/Multi player UI...
	var oMLBestOf = document.getElementById('mlbestofselect');
	var oMLMPBestOf = document.getElementById('mlmpbestofselect');
	var oMItemBestOf = document.getElementById(sBestOfCode);
	var oMMPItemBestOf = document.getElementById('mp' + sBestOfCode);
	oMLBestOf.selectedItem = oMItemBestOf;
	oMLMPBestOf.selectedItem = oMMPItemBestOf;

	document.getElementById('pong-window').focus();
}

function SwitchTypingNickName(bSet)
{
	bTyping = bSet;
	var bAllowReservedNick = false;
	if (bTyping == false)
	{
		sNickName = document.getElementById('tbnickname').value;
		if (IsValidString(sNickName) == false)
		{
			MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the nickname.');
			document.getElementById('tbnickname').value = "";
			document.getElementById('tbnickname').focus();
			return;
		}
		if (CheckPreferenceUserValue("allowreservednickname")) bAllowReservedNick = GetPreferenceBool("allowreservednickname");

		if (sNickName.toLowerCase().indexOf('captain') >= 0 && sNickName.toLowerCase().indexOf('caveman') >= 0 && bAllowReservedNick == false)
		{
			MessageBox('I am sorry, but I had to reserve this nickname for myself for technical reasons...\nPlease enter a different nickname.');
			document.getElementById('tbnickname').value = "";
			document.getElementById('tbnickname').focus();
			return;
		}
		SetPreferenceString("nickname", sNickName);
		SendNickName();
	}
}

function SwitchTyping(bSet)
{
	bTyping = bSet;
}

function PauseResume(bNotIfMultiplayer, bFromFocusChange)
{
	if (bNotIfMultiplayer == true && bMultiPlayer == true) return;

	if (bPlayerCanResumeGame == true)
	{
		if (bWaitToStart == false)
		{
			if (bFromFocusChange && bPaused == true) return;
			if (bPaused == true) return ResumeGame();
			return PauseGame(true);
		}
	}
	return false;
}

function PauseGame(bByPlayer)
{
	bPaused = true;
	sStatus = "P";
	if (bWaitToStart == false) oStatusMessage.setText('Game paused...');
	bPlayerCanResumeGame = bByPlayer;
	return true;
}

function ResumeGame()
{
	bPaused = false;
	sStatus = "A";
	oStatusMessage.Close();
	bPlayerCanResumeGame = true;
	return true;
}

function NewGame(iPlayers)
{
	if (TimerID != null)
	{
		//Make sure the timer(s) are stopped before we go any further...
		clearTimeout(TimerID);
		TimerID = null;
		return setTimeout('NewGame(' + iPlayers.toSource() + ');', 100);
	}
	ResetGame(iPlayers);

	if (iSpeed == 1) TimerID = setTimeout('GameLoop()', 60);
	if (iSpeed == 2) TimerID = setTimeout('GameLoop()', 40);
	if (iSpeed == 3) TimerID = setTimeout('GameLoop()', 25);
	if (iSpeed == 4) TimerID = setTimeout('GameLoop()', 15);
	if (iSpeed == 5)
	{
		TimerID = setTimeout('GameLoop()', 10);
		iBallVX = 10;
		iBallVY = 10;
		iAIVY = 10;
		iMPBallVX = 10;
		iMPBallVY = 10;
	}

	IntervalID = setInterval('UpdateGameTime()', 1000);
	if (bMultiPlayer == true)
	{
		SendLobbyChatMessage(MSG_PLAYSAGAINST + ' ' + sOpponentNickName + '*');

		bExchangeData = true;
		ExchangeDataID = setTimeout('ExchangePONGData(false, false);', 1);
		ResizePONG('mpgamechat');
	}
	else
	{
		ResizePONG('singleplayer');
	}
	return true;
}

function ResetGame(iPlayers)
{
	InitStart();

	document.getElementById('instructions').style.display = "none";
	document.getElementById('pongsettings').style.display = "none";
	document.getElementById('speedselect').style.display = "none";
	document.getElementById('bestofselect').style.display = "none";

	document.getElementById('multiplayer').style.display = "none";

	oBall.style.display = "block";
	oComputer.style.display = "block";
	oPlayer.style.display = "block";
	oComputerScore.style.display = "block";
	oPlayerScore.style.display = "block";
	document.getElementById('label_computer').style.display = "block";
	document.getElementById('label_player').style.display = "block";

	document.getElementById('line').style.display = "block";
	document.getElementById('statusinfo').style.display = "block";

	document.getElementById('label_computer').value = "Computer";
	document.getElementById('label_player').value = "Player";

	if (bMultiPlayer == true)
	{
		if (bStartedGame)
		{
			document.getElementById('label_computer').value = sOpponentNickName;
			document.getElementById('label_player').value = sNickName;
		}
		else
		{
			document.getElementById('label_computer').value = sNickName;
			document.getElementById('label_player').value = sOpponentNickName;
		}
		document.getElementById('vbgamechat').style.display = "block";

	}
	if (iPlayers == 2)
	{
		bTwoPlayerGame = true;
		document.getElementById('label_computer').value = "Player 2";
		document.getElementById('label_player').value = "Player 1";
	}
	bPaused = true;
	bWaitToStart = true
}

function InitMultiPlayer()
{
	if (sNickName == "")
	{
		var bContinue = false;
		while (bContinue == false)
		{
			sNickName = prompt('Please enter a nickname before you enter the Multiplayer Lobby.');
			if (!sNickName) sNickName = '';
			if (sNickName.toLowerCase().indexOf('captain') >= 0 && sNickName.toLowerCase().indexOf('caveman') >= 0 && bAllowReservedNick == false)
			{
				MessageBox('I am sorry, but I had to reserve this nickname for myself for technical reasons.\nPlease enter a different nickname.');
				sNickName = "";
			}
			if (IsValidString(sNickName) == false)
			{
				MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the nickname.');
				sNickName = "";
			}
			
			if (sNickName.length > 20)
			{
				MessageBox('The maximum length for your nickname is 20.\nPlease enter a different nickname.');
				sNickName = "";
			}
			if (sNickName != "") bContinue = true;
		}
		document.getElementById('tbnickname').value = sNickName;
		SetPreferenceString("nickname", sNickName);
	}
	else
	{
		if (IsValidString(sNickName) == false)
		{
			MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the nickname.');
			sNickName = "";
			InitMultiPlayer(); //Return to question.
		}
	}

	TimerID = 1; //So quit will return to main screen...
    bMultiPlayer = true;
	
	OpenConnection();

	document.getElementById('instructions').style.display = "none";
	document.getElementById('pongsettings').style.display = "none";
	document.getElementById('speedselect').style.display = "none";
	document.getElementById('bestofselect').style.display = "none";

	document.getElementById('multiplayer').style.display = "block";
	ClearPlayersList();

	ResizePONG('mplobbychat');
}

function ResetMultiPlayer()
{
	sPlayerID = "";
	sExternalIPAddress = "";
	sStatus = "W";
	sOpponentID = "";
	sDirectPlayInvitation = "";
	sOpponentNickName = "";
	sOpponentIPAddress = "";
	sOpponentStatus = "W";
	sWhoScored = "";
	bInGameConnected = false;
	bNonBlockingConnected = false;
	bBlockingConnected = false;
	iLastMPRead = 0;
	iLagTime = 0;
	iLagAlertCount = 0;
	document.getElementById('lagalert').style.display = "none";
	RemoveAllChildren(document.getElementById('gbponglobbychat'));
	RemoveAllChildren(document.getElementById('gbponggamechat'));
}

function ResizePONG(sResizeFor)
{
	sCurrentSizeMode = sResizeFor;
	switch (sResizeFor)
	{
	case 'mplobbychat':

		this.resizeTo(940,420);
		document.getElementById('pong-window').align = "left";
		document.getElementById('stack_main').width = 920;
		document.getElementById('stack_main').height = 350;
		document.getElementById('stack_main').top = 5;

		sChatStatus = 'L';
		bReturnToLobby = false;
		if (iPONGHTTPConnection == 1)
		{
			SendChatStatus();
			CheckLobbyChatMessage();
			CheckDirectPlayFriendsStatus();
		}

		break;
	case 'mpgamechat':
		this.resizeTo(420,600);
		document.getElementById('pong-window').align = "center";
		document.getElementById('stack_main').width = 380;
		document.getElementById('stack_main').height = 350;
		document.getElementById('stack_main').top = 20;
		document.getElementById('statusinfo_singleplayer').style.display = "none";

		sChatStatus = 'G';
		bReturnToLobby = true;
		SendChatStatus();

		break;
	case 'singleplayer':
		this.resizeTo(420,470);
		document.getElementById('pong-window').align = "center";
		document.getElementById('stack_main').width = 380;
		document.getElementById('stack_main').height = 350;
		document.getElementById('stack_main').top = 20;
		document.getElementById('statusinfo_singleplayer').style.display = "block";
		break;
	default:
		this.resizeTo(420,370);
		document.getElementById('stack_main').width = 380;
		document.getElementById('stack_main').height = 310;
		document.getElementById('stack_main').top = 5;
		document.getElementById('pong-window').align = "center";

		sChatStatus = 'N';
		bReturnToLobby = false;
		SendChatStatus();
	}
}

function QuitGame(bAndClose)
{
	bQuiting = true;
	CloseConnection();
	CloseInGameConnection();
	if (bMultiPlayer == true)
	{
		bExchangeData = false;
		clearTimeout(ExchangeDataID);
		SaveDirectPlayFriends();
		if (bReturnToLobby == true) return;
	}
	oStatusMessage.Close();
	ResizePONG('default');

    bMultiPlayer = false;

	if (bAndClose == false && TimerID != null) return InitStart();

	oSoundHitPlayerBatt = null;
	oSoundHitComputerBatt = null;
	oSoundHitWall = null;
	oSoundScore = null;
	oSoundMiss = null;
	oSoundWinGame = null;
	oSoundLooseGame = null;

	oBall = null;
	oComputer= null;
	oPlayer= null;
	oLine = null;
	oComputerScore = null;
	oPlayerScore = null;
	oGameTime = null;

	window.close();
	return true;
}

function ProcessKeyDown(oEvent)
{
	if (bTyping == true) return
	//Weird editable menulist thing...
	if ((document.commandDispatcher) && (document.commandDispatcher.focusedElement) && (document.commandDispatcher.focusedElement.nodeName) && (document.commandDispatcher.focusedElement.nodeName == 'html:input')) return;

	if (TimerID != null && bWaitToStart == true && (oEvent.keyCode == iP1KeyStart || oEvent.keyCode == iP2KeyStart))
	{
		if ((bMultiPlayer == false) || (bMultiPlayer == true && bStartedGame == true && bPlayer2Starts == false && bSmileyPopupIsShowing == false) || (bMultiPlayer == true && bStartedGame == false && bPlayer2Starts == true && bSmileyPopupIsShowing == false))
		{
			if (bPlaysWithKeyboard == false && iPlayerScore == 0 && iComputerScore == 0) bPlaysWithKeyboard = true;
			return StopWaitToStart(); //Space-bar
		}
	}

    if (oEvent.keyCode == iP1KeyUp)
	{
		if (bPlaysWithKeyboard == false && iPlayerScore == 0 && iComputerScore == 0) bPlaysWithKeyboard = true;
		return bPlayer1UpKeyDown = true;
	}
    if (oEvent.keyCode == iP1KeyDown)
	{
		if (bPlaysWithKeyboard == false && iPlayerScore == 0 && iComputerScore == 0) bPlaysWithKeyboard = true;
		return bPlayer1DownKeyDown = true;
	}

	if (bMultiPlayer == false)
	{
	    if (oEvent.keyCode == 49) return NewGame(1); //1
	    if (oEvent.keyCode == 50) return NewGame(2); //2
	}
	else
	{
	    if (oEvent.keyCode == 53) return SendQuickChatMessage('5'); //5
	    if (oEvent.keyCode == 54) return SendQuickChatMessage('6'); //6
	    if (oEvent.keyCode == 55) return SendQuickChatMessage('7'); //7
	    if (oEvent.keyCode == 56) return SendQuickChatMessage('8'); //8
	    if (oEvent.keyCode == 57) return SendQuickChatMessage('9'); //9
	}

    if (oEvent.keyCode == iP2KeyUp) return bPlayer2UpKeyDown = true;
    if (oEvent.keyCode == iP2KeyDown) return bPlayer2DownKeyDown = true;
    if (oEvent.keyCode == 77 && sCurrentSizeMode != "singleplayer") return InitMultiPlayer(); //M

    if (oEvent.keyCode == 80 && (sCurrentSizeMode == "singleplayer" || sCurrentSizeMode == "mpgamechat") && bGameFinished == false) return PauseResume(false); //P
    if (oEvent.keyCode == 81) return QuitGame(false); //Q
    if (oEvent.keyCode == 83) return OpenSettings(); //S
	return true;
}

function ProcessKeyUp(oEvent)
{
	if (oEvent.keyCode == iP1KeyUp || oEvent.keyCode == iP1KeyDown || oEvent.keyCode == iP2KeyUp || oEvent.keyCode == iP2KeyDown)
	{
		iKeyboardMoveSpeed = 5;
		iKeyDownTicks = 0;
	}

	if (bPlaysWithKeyboard == true)
	{
	    if (oEvent.keyCode == iP1KeyUp) return bPlayer1UpKeyDown = false;
	    if (oEvent.keyCode == iP1KeyDown) return bPlayer1DownKeyDown = false;
	}

    if (oEvent.keyCode == iP2KeyUp) return bPlayer2UpKeyDown = false;
    if (oEvent.keyCode == iP2KeyDown) return bPlayer2DownKeyDown = false;
}

function ProcessMouse(e)
{
	iMouseX = e.clientX;
	iMouseY = e.clientY;
}

function ProcessMouseDown(e)
{
	if (TimerID != null && bWaitToStart == true)
	{
		if ((iMouseY >= 0) && (iMouseY - 60 <= WINDOW_BOTTOM) && (iMouseX >= 0) && (iMouseX - 32 <= WINDOW_RIGHT))
		{
			if (bMultiPlayer == false)
			{
				if (bPlayer2Starts == false && e.button == 0)
				{
					StopWaitToStart();
					if (bPlaysWithKeyboard == true && iPlayerScore == 0 && iComputerScore == 0) bPlaysWithKeyboard = false;
				}
			}
			else
			{
				if (bHandledScore == true)
				{
					if ((bPlayer2Starts == false && e.button == 0 && bStartedGame == true) || (bPlayer2Starts == true && e.button == 0 && bStartedGame == false))
					{
						if (bSmileyPopupIsShowing == false)
						{
							StopWaitToStart();
							if (bPlaysWithKeyboard == true) bPlaysWithKeyboard = false;
						}
					}
				}
			}
		}
	}
	if (e.button == 2 && (sCurrentSizeMode == "singleplayer" || sCurrentSizeMode == "mpgamechat") && !bGameFinished) return PauseResume(false); //Right Mouse....
}

function GameLoop()
{
	if (TimerID == null) return;

	CheckWaitToStart();

	//Dynamicly change the keyboard move speed if this setting is on.
	if (bKeyboardAccelerationOn == true) iKeyboardMoveSpeed = iKeyboardMoveSpeed + (iKeyDownTicks / 5);

	if (bPaused == false)
	{
	    if (bTickCompleted == false) return; //Just to be sure, better to skip a tick, than to have overlapping ticks.
		bTickCompleted = false;

		//The main game loop...
		if (bMultiPlayer == false)
		{
			MovePlayer();
			MoveComputer();
			if (bPlaysWithKeyboard == true)
			{
				if (bPlayer1UpKeyDown == true) MovePlayer1Up();
				if (bPlayer1DownKeyDown == true) MovePlayer1Down();
			}
			if (bTwoPlayerGame == true)
			{
				if (bPlayer2UpKeyDown == true) MovePlayer2Up();
				if (bPlayer2DownKeyDown == true) MovePlayer2Down();
			}
			MoveBall();
		}
		else
		{
			//Multiplayer...
			sStatus = "A";

			if (bSmileyPopupIsShowing == false) MPMovePlayer();
			MPMoveOpponent();
			if (bPlaysWithKeyboard == true)
			{
				if (bPlayer1UpKeyDown == true) MPMovePlayerUp();
				if (bPlayer1DownKeyDown == true) MPMovePlayerDown();
				if (bPlayer2UpKeyDown == true) MPMovePlayerUp();
				if (bPlayer2DownKeyDown == true) MPMovePlayerDown();
			}
			MPMoveBall();
		}
		bTickCompleted = true;
	}
	else
	{
		iLagAlertCount = 0;
	}

	//Repeat the loop...
	if (iSpeed == 1) TimerID = setTimeout('GameLoop()', 60);
	if (iSpeed == 2) TimerID = setTimeout('GameLoop()', 40);
	if (iSpeed == 3) TimerID = setTimeout('GameLoop()', 25);
	if (iSpeed == 4) TimerID = setTimeout('GameLoop()', 15);
	if (iSpeed == 5)
	{
		TimerID = setTimeout('GameLoop()', 10);
	}
}

function StopWaitToStart()
{
	bPaused = false;
	bWaitToStart = false;
	bTickCompleted = true;
	bHandledScore = false;
	sWhoScored = '';
	if (bMultiPlayer == true)
	{
		sStatus = "A";
    	ExchangePONGData(true, true);
		document.getElementById('nofocusforgamechatedit').focus();
	}
}

function CheckWaitToStart()
{
	if (bWaitToStart == true)
	{
		if (bMultiPlayer == false)
		{
			MovePlayer();
			MoveComputer();
			if (bPlaysWithKeyboard == true)
			{
				if (bPlayer1UpKeyDown == true) MovePlayer1Up();
				if (bPlayer1DownKeyDown == true) MovePlayer1Down();
			}
			if (bTwoPlayerGame == true)
			{
				if (bPlayer2UpKeyDown == true) MovePlayer2Up();
				if (bPlayer2DownKeyDown == true) MovePlayer2Down();
			}

			if (bPlayer2Starts == false)
			{
				oBall.left = 340;
				oBall.top = parseInt(oPlayer.top) + 10;
				iBallVX = -8; //Always start moving away from player.
			}
			else
			{
				if (bTwoPlayerGame == true)
				{
					oBall.left = 25;
					oBall.top = parseInt(oComputer.top) + 10
					iBallVX = 8; //Always start moving away from player.
				}
			}
		}
		else
		{
			sStatus = "W";
			iLagAlertCount = 0;
			if (bHandledScore == true && bControlsGame == true)
			{
				if (bStartedGame == true && bPlayer2Starts == false) SendControl('F');
				if (bStartedGame == false && bPlayer2Starts == true) SendControl('F');
				if (bStartedGame == false && bPlayer2Starts == false) SendControl('T');
				if (bStartedGame == true && bPlayer2Starts == true) SendControl('T');
			}

			MPMovePlayer();
			MPMoveOpponent();

			if (bPlaysWithKeyboard == true)
			{
				if (bPlayer1UpKeyDown == true) MPMovePlayerUp();
				if (bPlayer1DownKeyDown == true) MPMovePlayerDown();
				if (bPlayer2UpKeyDown == true) MPMovePlayerUp();
				if (bPlayer2DownKeyDown == true) MPMovePlayerDown();
			}

			if (bPlayer2Starts == false)
			{
				oBall.left = 340;
				oBall.top = parseInt(oPlayer.top) + 10
				iBallVX = -8; //Always start moving away from player.
			}
			else
			{
				oBall.left = 25;
				oBall.top = parseInt(oComputer.top) + 10
				iBallVX = 8; //Always start moving away from player.
			}
		}

		if (bControlsGame == true)
		{
			iMPBallXPos = parseInt(oBall.left);
			iMPBallYPos = parseInt(oBall.top);
			iMPBallVX = iBallVX;
			iMPBallVY = iBallVY;
		}
	}
}

function UpdateGameTime()
{
	iGameTime += 1;

	UpdateAddictLevel();
}

function UpdateAddictLevel()
{
	var sLevel = "";

	if (iGameTime >= 0) sLevel = "Average PONG! player.";
	if (iGameTime >= 2700) sLevel = "Regular PONG! player.";
	if (iGameTime >= 5400) sLevel = "Frequent PONG! player.";
	if (iGameTime >= 10800) sLevel = "PONG! Addict.";
	if (iGameTime >= 16200) sLevel = "What other games?";
	if (iGameTime >= 21600) sLevel = "You should get out more.";
	if (iGameTime >= 33200) sLevel = "Now is your last chance to save your relationship.";
	if (iGameTime >= 43200) sLevel = "Do you even have a social live?";
	if (iGameTime >= 86400) sLevel = "Are you still there?";
	if (iGameTime >= 172800) sLevel = "Please contact a psychiatrist now!";
	if (iGameTime >= 200000) sLevel = "I am now the PONG! Master!";
	if (iGameTime >= 250000) sLevel = "All your PONG! are belong to us!";

	oGameTime.value = sLevel;
}

function MovePlayer()
{
	if (bPlaysWithKeyboard == false)
	{
		if ((iMouseY - 32 >= WINDOW_TOP) && (iMouseY - 32 <= WINDOW_BOTTOM) && oPlayer.top != iMouseY) oPlayer.top = iMouseY - 50;
	}
}

function MovePlayer1Up()
{
	var iPTop = parseInt(oPlayer.top);

	iKeyDownTicks ++;
	iPTop = iPTop - iKeyboardMoveSpeed;
	if (iPTop < 0) iPTop = 0;
	if (iPTop >= 0) oPlayer.top = iPTop;
}

function MovePlayer1Down()
{
	var iPTop = parseInt(oPlayer.top);

	iKeyDownTicks ++;
	iPTop = iPTop + iKeyboardMoveSpeed;
	if ((iPTop + 17) > WINDOW_BOTTOM) iPTop = WINDOW_BOTTOM - 19;
	if ((iPTop + 17) <= WINDOW_BOTTOM) oPlayer.top =  iPTop;
}

function MovePlayer2Up()
{
	var iCTop = parseInt(oComputer.top);

	iKeyDownTicks ++;
	iCTop = iCTop - iKeyboardMoveSpeed;
	if (iCTop < 0) iCTop = 0;
	if (iCTop >= 0) oComputer.top = iCTop;
}

function MovePlayer2Down()
{
	var iCTop = parseInt(oComputer.top);

	iKeyDownTicks ++;
	iCTop = iCTop + iKeyboardMoveSpeed;
	if ((iCTop + 17) > WINDOW_BOTTOM) iCTop = WINDOW_BOTTOM - 19;
	if ((iCTop + 17) <= WINDOW_BOTTOM) oComputer.top =  iCTop;
}

function MoveComputer()
{
	if (bTwoPlayerGame == false)
	{
		var iTop  = parseInt(oBall.top);
		var iLeft  = parseInt(oBall.left);
		var iCTop  = parseInt(oComputer.top);

		if (iLeft >= 28 && iLeft <= 40)
		{
			if (iTop > 156) iAIHighBalls ++;
			if (iTop < 156) iAILowBalls ++;
		}

		if (iBallVX > 0)
		{
			//Move to where the most balls have come so far if we just hit the ball away.
	    	if (iCTop > 100 && iAILowBalls > (iAIHighBalls + 3)) iCTop = iCTop - iAIVY;
	    	if (iCTop < 200 && iAIHighBalls > (iAILowBalls + 3)) iCTop = iCTop + iAIVY;
		}
		else
		{
			if (bAIOn == true)
			{
				//Make im look 'smarter' AI...
				if (iLeft >= 30 && iLeft <= 90 && (iBallVY < 0 && iTop <= (WINDOW_TOP + 30) || iBallVY > 0 && iTop >= (WINDOW_BOTTOM - 30)) && iCTop < 40)
				{
					//Do nothing special for now...
				}
				else
				{
					if ((iBallVY == 12 || iBallVY == -12) && iLeft > 160)
					{
						if (iCTop > (WINDOW_BOTTOM - (iTop - WINDOW_TOP))) iCTop = iCTop - iAIVY;
						if (iTop < (WINDOW_BOTTOM - (iTop - WINDOW_TOP))) iCTop = iCTop + iAIVY;
					}
					else
					{
						//Standard 'move to ball' AI...
						if (iTop - 5 > iCTop) iCTop = iCTop + iAIVY;
						if (iTop + 5 < iCTop) iCTop = iCTop - iAIVY;
					}
				}
			}
			else
			{
				//Standard 'move to ball' AI...
				if (iTop >= iCTop) iCTop = iCTop + iAIVY;
				if (iTop <= iCTop) iCTop = iCTop - iAIVY;
			}
		}
		if ((iCTop >= -2) && ((iCTop + 17) <= WINDOW_BOTTOM) && oComputer.top != iCTop) oComputer.top = iCTop;
	}
}

function RandomSwitchAI(iPlayerScoreWas, iComputerScoreWas)
{
	if (iPlayerScoreWas == iPlayerScore && iComputerScoreWas == iComputerScore && (iPlayerScore - iComputerScore) >= 3)
	{
		var iRand = 0;
		bAIOn = !bAIOn;
		if (bAIOn == true)
		{
			iAIVY = 12;
			iRand = Math.random() * 10000;
		}
		else
		{
			iAIVY = 8;
			iRand = Math.random() * 7500;
		}
		
		setTimeout('RandomSwitchAI(' + iPlayerScore.toSource() + ', ' + iComputerScore.toSource() + ');', iRand);
	}
}

function MoveBall()
{
	var iLeft = parseInt(oBall.left);
	var iTop  = parseInt(oBall.top);
	var iPTop  = parseInt(oPlayer.top);
	var iCTop  = parseInt(oComputer.top);

	//Check for ball beyond batt...
	if ((iLeft + 15) >= (WINDOW_RIGHT))
	{
		if ( ((iTop + 10) >= iPTop) && (iTop - 4 <= (iPTop + iBattHeight + 2)) ) //Add extra margin of 4.
		{
			PlaySound('hitplayerbatt');
			iBallVX = parseInt(iBallVX) * -1;
			iBallVY = GetBallVY(iPTop, iTop, iBattHeight);
		}
		else
		{
			PlaySound('computerscore');
			StartNextLevel(false);
			return true;
		}
	}
	else
	{
		var iRDiv = WINDOW_RIGHT - (iLeft + 15);
		if (iRDiv <= 7 && iRDiv >= 1 && iBallVY == 8) iLeft = WINDOW_RIGHT - 23;
	}

	if (iLeft - 4 <= WINDOW_LEFT)
	{
		if ( ((iTop + 6) >= iCTop) && (iTop <= (iCTop + iBattHeight + 2)) ) //NO extra margin of 2.
		{
			PlaySound('hitcomputerbatt');
			iBallVX = parseInt(iBallVX) * -1;
			iBallVY = GetBallVY(iCTop, iTop, iBattHeight);
			if (bJustStartedSet == true)
			{
				bJustStartedSet = false;
				iAIVY = 8;
			}
		}
		else
		{
			PlaySound('playerscore');
			StartNextLevel(true);
			return true;
		}
	}
	else
	{
		var iLDiv = iLeft - WINDOW_LEFT;
		if (iLDiv <= 7 && iLDiv >= 1 && iBallVY == -8) iLeft = WINDOW_LEFT + 12;
	}


	//Check for wall hit...
	if ( ((iTop - 4) >= (WINDOW_BOTTOM)) || (iTop + 17 <= WINDOW_TOP) )
	{
		PlaySound('hitwall');
		iBallVY = parseInt(iBallVY) * -1;
	}
	else
	{
		var iBDiv = WINDOW_BOTTOM - (iTop - 4);
		var iTDiv = WINDOW_TOP - (iTop + 17);

		if (iBDiv <= 11 && iBDiv >= 1 && iBallVY == 12) iTop = WINDOW_BOTTOM - 8;
		if (iBDiv <= 7 && iBDiv >= 1 && iBallVY == 8) iTop = WINDOW_BOTTOM - 4;
		if (iTDiv >= -11 && iTDiv <= -1 && iBallVY == -12) iTop = WINDOW_TOP - 5;
		if (iTDiv >= -7 && iTDiv <= -1 && iBallVY == -8) iTop = WINDOW_TOP - 9;
	}

	oBall.left = iLeft + parseInt(iBallVX);
	oBall.top  = iTop + parseInt(iBallVY);
	return true;
}

function MPMovePlayer()
{
	if (bPlaysWithKeyboard == false)
	{
		if (bStartedGame == true)
		{
			if ((iMouseY - 32 >= WINDOW_TOP) && (iMouseY - 32 <= WINDOW_BOTTOM) && oPlayer.top != iMouseY - 50) oPlayer.top = iMouseY - 50;
		}
		else
		{
			if ((iMouseY - 32 >= WINDOW_TOP) && (iMouseY - 32 <= WINDOW_BOTTOM) && oComputer.top != iMouseY - 50) oComputer.top = iMouseY - 50;
		}
	}
}

function MPMovePlayerUp()
{
	iKeyDownTicks ++;
	if (bStartedGame == true)
	{
		var iPTop = parseInt(oPlayer.top);
		iPTop = iPTop - iKeyboardMoveSpeed;
		if (iPTop < 0) iPTop = 0;
		if (iPTop >= 0) oPlayer.top = iPTop;
	}
	else
	{
		var iCTop = parseInt(oComputer.top);
		iCTop = iCTop - iKeyboardMoveSpeed;
		if (iCTop < 0) iCTop = 0;
		if (iCTop >= 0) oComputer.top = iCTop;
	}
}

function MPMovePlayerDown()
{
	iKeyDownTicks ++;
	if (bStartedGame == true)
	{
		var iPTop = parseInt(oPlayer.top);
		iPTop = iPTop + iKeyboardMoveSpeed;
		if ((iPTop + 17) > WINDOW_BOTTOM) iPTop = WINDOW_BOTTOM - 19;
		if ((iPTop + 17) <= WINDOW_BOTTOM) oPlayer.top =  iPTop;
	}
	else
	{
		var iCTop = parseInt(oComputer.top);
		iCTop = iCTop + iKeyboardMoveSpeed;
		if ((iCTop + 17) > WINDOW_BOTTOM) iCTop = WINDOW_BOTTOM - 19;
		if ((iCTop + 17) <= WINDOW_BOTTOM) oComputer.top =  iCTop;
	}
}

function MPMoveOpponent()
{
	if (bStartedGame == true)
	{
		if (oComputer.top != iOpponentYPos) oComputer.top = iOpponentYPos;
	}
	else
	{
		if (oPlayer.top != iOpponentYPos) oPlayer.top = iOpponentYPos;
	}
}

function MPMoveBall()
{
	iTicksSinceLastSound ++;
	iTicksSinceSendControl ++;

	var iLeft = parseInt(oBall.left);
	var iTop  = parseInt(oBall.top);
	var iPTop  = parseInt(oPlayer.top);
	var iCTop  = parseInt(oComputer.top);
	var iPrevLeft = iLeft - iBallVX;
	var iPrevTop = iTop - iBallVY;
	var iPrevBallVX = iBallVX;
	var iPrevBallVY = iBallVY;

	if ((iLeft > 20 && iLeft < 45) || (iLeft > (WINDOW_CENTER - 12) && iLeft < (WINDOW_CENTER + 12)) || (iLeft > (WINDOW_RIGHT - 45) && iLeft < (WINDOW_RIGHT - 20)))
	{
		//Do a blocking write at these points.
		ExchangePONGData(true, true);
	}

	//Check for ball beyond batt...
	if ((iLeft + 17) >= WINDOW_RIGHT)
	{
		if ( ((iTop + 10) >= iPTop) && (iTop - 4 <= (iPTop + iBattHeight + 2)) ) //Add extra margin of 4.
		{
			if (bStartedGame == true) PlaySound('hitplayerbatt');
			if (bStartedGame == false) PlaySound('hitcomputerbatt');
			iBallVX = parseInt(iBallVX) * -1;
			iBallVY = GetBallVY(iPTop, iTop, iBattHeight);
		}
		else
		{
			if (bControlsGame == true)
			{
				if (bStartedGame == true)
				{
					PlaySound('computerscore');
					sWhoScored = '2';
					StartNextLevel(false);
				}
				else
				{
					PlaySound('playerscore');
					sWhoScored = '1';
					StartNextLevel(true);
				}
				return true;
			}
			else
			{
				//Asume hit, until told otherwise...
				iBallVX = parseInt(iBallVX) * -1;
				iBallVY = GetBallVY(iPTop, iTop, iBattHeight);
				PlaySound('hitplayerbatt');
			}
		}
	}
	else
	{
		var iRDiv = WINDOW_RIGHT - (iLeft + 17);
		if (iRDiv <= 7 && iRDiv >= 1 && iBallVY == 8) iLeft = WINDOW_RIGHT - 23;
	}

	if (iLeft - 2 <= WINDOW_LEFT)
	{
		if ( ((iTop + 10) >= iCTop) && (iTop - 4 <= (iCTop + iBattHeight + 2)) ) //Add extra margin of 4.
		{
			if (bStartedGame == true) PlaySound('hitcomputerbatt');
			if (bStartedGame == false) PlaySound('hitplayerbatt');
			iBallVX = parseInt(iBallVX) * -1;
			iBallVY = GetBallVY(iCTop, iTop, iBattHeight);
		}
		else
		{
			if (bControlsGame == true)
			{
				if (bStartedGame == true)
				{
					PlaySound('playerscore');
					sWhoScored = '1';
					StartNextLevel(true);
				}
				else
				{
					PlaySound('computerscore');
					sWhoScored = '2';
					StartNextLevel(false);
				}
				return true;
			}
			else
			{
				//Asume hit, until told otherwise...
				iBallVX = parseInt(iBallVX) * -1;
				iBallVY = GetBallVY(iCTop, iTop, iBattHeight);
				PlaySound('hitcomputerbatt');
			}
		}
	}
	else
	{
		var iLDiv = iLeft - WINDOW_LEFT;
		if (iLDiv <= 7 && iLDiv >= 1 && iBallVY == -8) iLeft = WINDOW_LEFT + 16;
	}

	//Check for wall hit...
	if ( ((iTop - 4) >= (WINDOW_BOTTOM)) || (iTop + 17 <= WINDOW_TOP) )
	{
		PlaySound('hitwall');
		iBallVY = parseInt(iBallVY) * -1;
	}
	else
	{
		var iBDiv = WINDOW_BOTTOM - (iTop - 4);
		var iTDiv = WINDOW_TOP - (iTop + 17);

		if (iBDiv <= 11 && iBDiv >= 1 && iBallVY == 12) iTop = WINDOW_BOTTOM - 8;
		if (iBDiv <= 7 && iBDiv >= 1 && iBallVY == 8) iTop = WINDOW_BOTTOM - 4;
		if (iTDiv >= -11 && iTDiv <= -1 && iBallVY == -12) iTop = WINDOW_TOP - 5;
		if (iTDiv >= -7 && iTDiv <= -1 && iBallVY == -8) iTop = WINDOW_TOP - 9;
	}

	//Check for ball position error (to come...)
	if (iTop + parseInt(iBallVY) - 4 >= WINDOW_BOTTOM) iTop = WINDOW_BOTTOM + 4 - parseInt(iBallVY);
	if (iTop + parseInt(iBallVY) + 17 <= WINDOW_TOP) iTop = WINDOW_TOP - 17 - parseInt(iBallVY);
	if (iLeft + parseInt(iBallVX) - 3 <= WINDOW_LEFT) iLeft = WINDOW_LEFT + 2 - parseInt(iBallVX);
	if (iLeft + parseInt(iBallVX) + 17 >= WINDOW_RIGHT) iLeft = WINDOW_RIGHT - 17 - parseInt(iBallVX);

	if (bControlsGame == true)
	{
		//Check the positions if we have just the control...
		if (aPastPositions && aPastPositions.length > 0)
		{
			aPastPositions[aPastPositions.length] = new Array(iPrevLeft, iPrevTop, iPrevBallVX, iPrevBallVY);
			aPastPositions[aPastPositions.length] = new Array(iLeft, iTop, iBallVX, iBallVY);
			aPastPositions[aPastPositions.length] = new Array(iLeft + iBallVX, iTop + iBallVY, iBallVX, iBallVY);

			if (CheckPastPositions() == false)
			{
				iLeft = iMPBallXPos;
				iTop  = iMPBallYPos;
				iBallVX = iMPBallVX;
				iBallVY = iMPBallVY;
			}
			aPastPositions = null;//iLagTime
		}

		if (((oBall.left > WINDOW_CENTER - 10 && bStartedGame == true) || (oBall.left < WINDOW_CENTER + 10 && bStartedGame == false)) || iLagTime < ELRS_TIME)
		{
			oBall.left = iLeft + parseInt(iBallVX);
			oBall.top  = iTop + parseInt(iBallVY);
		}

		iMPBallXPos = parseInt(oBall.left);
		iMPBallYPos = parseInt(oBall.top);
		iMPBallVX = iBallVX;
		iMPBallVY = iBallVY;

		if ((oBall.left <= WINDOW_CENTER && bStartedGame == true) || (oBall.left >= WINDOW_CENTER && bStartedGame == false))
		{
			if (iTicksSinceSendControl > 3)
			{
				iTicksSinceSendControl = 0;
				SendControl('T');
				if (aPastPositions == null) aPastPositions = new Array;
				aPastPositions[aPastPositions.length] = new Array(iPrevLeft, iPrevTop, iPrevBallVX, iPrevBallVY);
				aPastPositions[aPastPositions.length] = new Array(iLeft, iTop, iBallVX, iBallVY);
				aPastPositions[aPastPositions.length] = new Array(iLeft + iBallVX, iTop + iBallVY, iBallVX, iBallVY);
			}
		}
	}
	else
	{
		if (bDataIsCurrent == true)
		{
			if (aPastPositions == null) aPastPositions = new Array;
			aPastPositions[aPastPositions.length] = new Array(iPrevLeft, iPrevTop, iPrevBallVX, iPrevBallVY);
			aPastPositions[aPastPositions.length] = new Array(iLeft, iTop, iBallVX, iBallVY);
			aPastPositions[aPastPositions.length] = new Array(iLeft + iBallVX, iTop + iBallVY, iBallVX, iBallVY);

			if (CheckPastPositions() == false)
			{
				iLeft = iMPBallXPos;
				iTop  = iMPBallYPos;
				iBallVX = iMPBallVX;
				iBallVY = iMPBallVY;
			}
			aPastPositions = null;
			bDataIsCurrent = false;

			if ((iLeft + parseInt(iBallVX)) >= WINDOW_CENTER && iBallVX > 0 && bStartedGame == true)
			{
				iMPBallXPos = iLeft + parseInt(iBallVX);
				iMPBallYPos = iTop + parseInt(iBallVY);
				iMPBallVX = iBallVX;
				iMPBallVY = iBallVY;
			}
			if ((iLeft + parseInt(iBallVX)) <= WINDOW_CENTER && iBallVX < 0 && bStartedGame == false)
			{
				iMPBallXPos = iLeft + parseInt(iBallVX);
				iMPBallYPos = iTop + parseInt(iBallVY);
				iMPBallVX = iBallVX;
				iMPBallVY = iBallVY;
			}
		}
		if (((iLeft + parseInt(iBallVX) < WINDOW_CENTER + 10 && bStartedGame == true) || (iLeft + parseInt(iBallVX) > WINDOW_CENTER - 10 && bStartedGame == false)) || iLagTime < ELRS_TIME)
		{
			oBall.left = iLeft + parseInt(iBallVX);
			oBall.top  = iTop + parseInt(iBallVY);
		}

		if (aPastPositions == null) aPastPositions = new Array;
		aPastPositions[aPastPositions.length] = new Array(iLeft, iTop, iBallVX, iBallVY);
	}

	//Check for ball position error (to come...)
	if (iMPBallYPos + parseInt(iMPBallVY) - 4 >= WINDOW_BOTTOM) iMPBallYPos = WINDOW_BOTTOM + 4 - parseInt(iMPBallVY);
	if (iMPBallYPos + parseInt(iMPBallVY) + 17 <= WINDOW_TOP) iMPBallYPos = WINDOW_TOP - 17 - parseInt(iMPBallVY);
	if (iMPBallXPos + parseInt(iMPBallVX) - 4 <= WINDOW_LEFT) iMPBallXPos = WINDOW_LEFT + 4 - parseInt(iMPBallVX);
	if (iMPBallXPos + parseInt(iMPBallVX) + 15 >= WINDOW_RIGHT) iMPBallXPos = WINDOW_RIGHT - 15 - parseInt(iMPBallVX);
	return true;
}

function CheckPastPositions()
{
	var iIndex, iLen;

	if (aPastPositions != null)
	{
		iLen = aPastPositions.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (aPastPositions[iIndex][0] == iMPBallXPos && aPastPositions[iIndex][1] == iMPBallYPos && aPastPositions[iIndex][2] == iMPBallVX && aPastPositions[iIndex][3] == iMPBallVY)
			{
				return true;
			}
		}
		if (aPastPositions.length == 2) return true;
		if (aPastPositions.length >= 4)
		{
			if (aPastPositions[aPastPositions.length - 3][2] == iMPBallVX && aPastPositions[aPastPositions.length - 3][3] == iMPBallVY && aPastPositions[aPastPositions.length - 4][2] == iMPBallVX && aPastPositions[aPastPositions.length - 4][3] == iMPBallVY) return true;
		}
		return false;
	}
	return true;
}

function GetBallVY(iBattY, iBallY, iBattHeight)
{
	var iDiv = ((parseInt(iBattY) + parseInt(iBattHeight)) - parseInt(iBallY));
	if (iSpeed == 5)
	{
		if ((iDiv >= -20) && (iDiv < 8))   return  14;
		if ((iDiv >= 8) && (iDiv < 16))  return  10;
		if ((iDiv >= 16) && (iDiv < 24)) return  0;
		if ((iDiv >= 24) && (iDiv < 32)) return -10;
		if ((iDiv >= 32) && (iDiv < 60)) return -14;
	}
	if ((iDiv >= -20) && (iDiv < 8))   return  12;
	if ((iDiv >= 8) && (iDiv < 16))  return  8;
	if ((iDiv >= 16) && (iDiv < 24)) return  0;
	if ((iDiv >= 24) && (iDiv < 32)) return -8;
	if ((iDiv >= 32) && (iDiv < 60)) return -12;
	return 0;
}

function StartNextLevel(bPlayerScored)
{
	aPastPositions = null;

	//Prevent double score caused by a the fact that we don't know if the other player has received a msg.
	if (bHandledScore == true) return false;
	if (bWaitToStart == true) return false; //Should never be possible...

	bPaused = true;
	bWaitToStart = true;

	if (bMultiPlayer == false)
	{
		if (bPlayerScored)
		{
			iPlayerScore += 1;
			bPlayer2Starts = false;
		}
		else
		{
			iComputerScore += 1;
			if (bTwoPlayerGame == true) bPlayer2Starts = true;
		}
		//Switch AI on/off
		if ((iPlayerScore - iComputerScore) >= 3)
		{
			bJustStartedSet = false;
			iAIVY = 12;
			RandomSwitchAI(iPlayerScore, iComputerScore);
		}
		else
		{
			bJustStartedSet = true;
			iAIVY = 12; //Only untill the first hit to avoid direct score...
			if ((Math.random() * 10) < 4) iAIVY = 8; //Make it randomly possible again to score an ace.
			bAIOn = false;
		}
		oComputerScore.value = iComputerScore;
		oPlayerScore.value = iPlayerScore;
	}
	else
	{
		if (bPlayerScored)
		{
			iPlayerScore += 1;
			if (bStartedGame == true)
			{
				bPlayer2Starts = false;
			}
			else
			{
				bPlayer2Starts = true;
			}
		}
		else
		{
			iComputerScore += 1;
			if (bStartedGame == true)
			{
				bPlayer2Starts = true;
			}
			else
			{
				bPlayer2Starts = false;
			}
		}

		if (bStartedGame == true)
		{
			oComputerScore.value = iComputerScore;
			oPlayerScore.value = iPlayerScore;
		}
		else
		{
			oComputerScore.value = iPlayerScore;
			oPlayerScore.value = iComputerScore;
		}
	}
	iBallVY = parseInt(iBallVY) * -1;

    if (bMultiPlayer == true && bControlsGame == true) SendScored();

	//Check for win/loose.
	if (iPlayerScore == iBestOf)
	{
		PlaySound("wingame");
		bPaused = true;
		bWaitToStart = false;
		bGameFinished = true;
	}
	if (iComputerScore == iBestOf)
	{
		PlaySound("loosegame");
		bPaused = true;
		bWaitToStart = false;
		bGameFinished = true;
	}
	return true;
}

function PlaySound(sEvent)
{
	if (bSoundOn == false) return false;

	//Prevent double hit-sound caused by a position correction.
	if (iTicksSinceLastSound >= 1 && iTicksSinceLastSound <= 3 && sEvent.substr(0, 3) == 'hit') return false;

	switch (sEvent)
	{
	case 'playerscore':
		oSoundScore.play();
		break
	case 'computerscore':
		oSoundMiss.play();
		break
	case 'hitplayerbatt':
		oSoundHitPlayerBatt.play();
		break
	case 'hitcomputerbatt':
		oSoundHitComputerBatt.play();
		break
	case 'hitwall':
		oSoundHitWall.play();
		break
	case 'wingame':
		oSoundWinGame.play();
		break
	case 'loosegame':
		oSoundLooseGame.play();
		break
	}
	iTicksSinceLastSound = 0;
	return true
}

//Multiplayer stuff...
function OpenConnection(bDontDisplayMessages)
{
	DisableMPControls(true);

	if (iPONGHTTPConnection == 1) return;

    iPONGHTTPConnection = 2;

	if (!bDontDisplayMessages) oStatusMessage.setText('Connecting...');
	setTimeout('TestConnection(0, ' + bDontDisplayMessages + ');', 1000);
}

function TestConnection(iTries, bDontDisplayMessages)
{
	if (iPONGHTTPConnection >= 1)
	{
        if (iTries == 0)
        {
            WriteData('', 1);
            iTries ++;
            if (iTries < 4) return setTimeout('TestConnection(' + iTries.toSource() + ', ' + bDontDisplayMessages + ');', 1000);
        }
        else WriteData('getpid' + SEP_MESSAGES + sNickName + SEP_MESSAGES + PONG_VERSION);
	}
	else
	{
		iTries ++;
		if (iTries < 4) return setTimeout('TestConnection(' + iTries.toSource() + ', ' + bDontDisplayMessages + ');', 1000);
		if (!bDontDisplayMessages)
        {
            MessageBox('An error occured while connecting to the PONG! server.\nThis might be because since may 2007 I had to shut down my server, and since then PONG! Multiplayer is only available when my desktop is online (usually all evening, GMT+1).');
            oStatusMessage.Close();
        }
	}
	return true;
}

function CloseConnection()
{
	if (iPONGHTTPConnection != 0)
	{
		sStatus = "Q";
		bExchangeData = true;
		ExchangePONGData(true, true);
    	bExchangeData = false;

        WriteData('', 0);
		iPONGHTTPConnection = 0;
		setTimeout('CloseConnection();', 500);
	}
	else
	{
		ResetMultiPlayer();
		if (bReturnToLobby == true) setTimeout('InitStart(); InitMultiPlayer();', 1000);
	}
}

function WriteData(sData, iConnect)
{
	if (iPONGHTTPConnection >= 1)
    {
        var oRequest = new XMLHttpRequest();
        
        var sURI = "http://pongmplobby.captaincaveman.nl/PONGHandler.ashx";
        if (iConnect == 0 || iConnect == 1)
        {
            sURI = sURI + "?connect=" + iConnect;
        }
        else
        {
            sURI = sURI + "?commands=" + sData;
        }
        if (sPlayerID && sPlayerID != "") sURI = sURI + "&playerid=" + sPlayerID;
        
        oRequest.open("GET", sURI, true);
        oRequest.overrideMimeType("text/plain");
        oRequest.onreadystatechange = function(oEvent)
        {
            try
            {
                if (oRequest.readyState == 4)
                {
                    if (oRequest.status != 404 && oRequest.responseText)
                    {
                        ProcessReceivedPONGData(oRequest.responseText);
                    }
                }
            } catch(e) {}
        }
        oRequest.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
        oRequest.setRequestHeader("Cache-Control", "no-cache");
        oRequest.send(null);        
    }
}

function ProcessReceivedPONGData(Data)
{
	var iIndex, iLen, iPos;
	var sCommand = "";
	var sData = "";
	var aData;
	var sLastEDData = "";

	if (bQuiting == true) return false;

	aData = Data.split(SEP_COMMANDS);
	iLen = aData.length;
	if (iLen >= 1)
	{
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (aData[iIndex] != "")
			{
				iPos = aData[iIndex].indexOf(SEP_COMMAND);
				sCommand = aData[iIndex].substr(0, iPos);
				sData = aData[iIndex].substring(iPos + 1, aData[iIndex].length);
				if (sCommand != 'ed')
				{
					ExecutePONGCommand(sCommand, sData);
				}
				else
				{
					sLastEDData = sData;
				}
			}
		}
		if (sLastEDData != '') ExecutePONGCommand('ed', sLastEDData);
	}

	return true;
}

function ExecutePONGCommand(sCommand, sData)
{
	if (sCommand == 'server') CheckPONGServerMsg(sData);
	if (sCommand == 'pid') SetPlayerID(sData);
	if (sCommand == 'join') SetJoinedPlayer(sData);
	if (sCommand == 'joined') SetJoinAccepted(sData);
	if (sCommand == 'getplayers') SetPlayers(sData);
	if (sCommand == 'ed') SetPONGData(sData);
	if (sCommand == 'score') CheckScored(sData);
	if (sCommand == 'control') CheckControl(sData);
	if (sCommand == 'getlobbychat') SetLobbyChatMessages(sData);
	if (sCommand == 'getgamechat') SetGameChatMessages(sData);
	if (sCommand == 'dpfound') SetDirectPlayPIDs(sData);
	if (sCommand == 'dpstatus') SetDirectPlayFriendsStatus(sData);
	if (sCommand == 'dpinvite') ReadDirectPlayInvitation(sData);
	if (sCommand == 'igconnected') SetInGameConnected(sData);
	if (sCommand == 'testconnection') ProcessConnectionTestResult(sData);	
}

function SendNickName()
{
	//Also causes the status to be reset.
	WriteData('getpid' + SEP_MESSAGES + sNickName + SEP_MESSAGES + PONG_VERSION);
}

function SendIPAddress()
{
	var sIPAddress = ""
	if (bPlayOnLAN == true) sIPAddress = GetIPAddress();
	if (iPONGHTTPConnection == 1) WriteData('setip' + SEP_MESSAGES + sIPAddress);
}

function CheckPONGServerMsg(sData)
{
	if (sData == "DISCONNECT")
	{
		if (bQuiting == false)
		{
			CloseConnection();
			MessageBox("The server has disconnected all PONG! games for server maintenance.\nPlease try again in +/- 15 minutes.");
			QuitGame(false);
		}
	}
	if (sData == "WRONG_VERSION")
	{
		CloseConnection();
		MessageBox("A newer version of PONG! is available, please update before starting multiplayer.");
		QuitGame(false);
	}
	if (sData == "UNKNOWN_ERROR")
	{
		CloseConnection();
		MessageBox("Could no longer find your session ID on the server, please reopen the Multiplayer Lobby.");
		QuitGame(false);
	}
}

function SetPlayerID(sData)
{
	var aData;
	aData = sData.split(SEP_MESSAGES);

	if (sPlayerID == '' || iPONGHTTPConnection == 1)
	{
  		sPlayerID = aData[0];

        if (iPONGHTTPConnection == 2)
        {
            iPONGHTTPConnection = 1;
        }
        else
        {
    		oStatusMessage.Close();
    		DisableMPControls(false);

    		SendChatStatus();
    		SendIPAddress();
    		CheckLobbyChatMessage();
    		CheckDirectPlayFriendsStatus();
    		GetPongPlayers();
        }
	}
	sExternalIPAddress = aData[1];
}

function SetJoinedPlayer(sData)
{
	var aData;

	aData = sData.split(SEP_MESSAGES);
	sOpponentID = aData[0];
	sOpponentNickName = aData[1];
	sOpponentIPAddress = aData[2];

	//Automaticly add to Direct Play list.
	AddDirectPlayFriend(aData[2], sOpponentNickName);

	bStartedGame = true;
	bControlsGame = true;
	bHandledScore = true;
	OpenInGameConnection();
}

function WaitForJoinAccepted(iTries)
{
	var sStatus = oStatusMessage.getText();
	var sNewStatus = "";

	if (sStatus == "Enjoy!" || bInGameConnected == true || bNonBlockingConnected == true || bBlockingConnected == true || oTimedServerSocket != null || oLoopServerSocket != null) return true;

	if (sStatus == "Waiting...") sNewStatus = "Waiting";
	if (sStatus == "Waiting..") sNewStatus = "Waiting...";
	if (sStatus == "Waiting.") sNewStatus = "Waiting..";
	if (sStatus == "Waiting") sNewStatus = "Waiting.";

	if (sNewStatus != "") oStatusMessage.setText(sNewStatus);

	iTries ++
	if (iTries > 9)
	{
		MessageBox('The game you selected is no longer available.\nPlease refresh the list of available games, and select an other game.');

		oStatusMessage.Close();
		DisableMPControls(false);

		return;
	}
	return setTimeout('WaitForJoinAccepted(' + iTries.toSource() + ');', 1000);
}

function SetJoinAccepted(sData)
{
	if (sData != "F" && sData != "")
	{
		sOpponentIPAddress = sData;
		//Automaticly add to Direct Play list.
		AddDirectPlayFriend(sData, sOpponentNickName);

		bStartedGame = false;
		bControlsGame = false;
		bHandledScore = false;
		OpenInGameConnection();
	}
}

function CheckDirectPlayFriendsStatus()
{
	var sFriends = "";
	var iLen = aDirectPlayFriends.length;
	var iIndex;

	if (sChatStatus != 'L') return;
	if (iPONGHTTPConnection == 0 || iPONGHTTPConnection == -1) return setTimeout('CheckDirectPlayFriendsStatus();', 100);

	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		sFriends += aDirectPlayFriends[iIndex][0] + aDirectPlayFriends[iIndex][1];
	}
	WriteData('dpstatus' + SEP_MESSAGES + sFriends);
	if (sChatStatus == 'L') return setTimeout('CheckDirectPlayFriendsStatus();', 30000);
	return true;
}

function SetDirectPlayFriendsStatus(sData)
{
	var oMenu = document.getElementById('mlmpdirectplayselect');
	if (oMenu.open == true) return;
	if (oMenu.selectedItem) return;
	var oBoxObject = oMenu.boxObject;
	var onsIBoxObject = oBoxObject.QueryInterface(Components.interfaces.nsIMenuBoxObject);
	if (onsIBoxObject.element.inputField.value != "") return;
	var oMItem;
	var aFriends = sData.split(SEP_MESSAGES);
	var aStatus = new Array;
	var aFriend;
	var sStatus;
	var iDPFIndex, iDPFLen;
	var iIndex, iLen;
	var iFound;

	RemoveAllChildren(oMenu);

	iDPFLen = aDirectPlayFriends.length;
	for (iDPFIndex = 0; iDPFIndex < iDPFLen; iDPFIndex ++)
	{
		iFound = 0;
		iLen = aFriends.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			iFound = 0;
			aFriend = aFriends[iIndex].split(SEP_MESSAGE);
			if (aFriend[1] == aDirectPlayFriends[iDPFIndex][0]) iFound ++;
			if (aFriend[2] == aDirectPlayFriends[iDPFIndex][1]) iFound ++;
			if (iFound == 2) break; //Exact match found...
    	}
		aStatus[iDPFIndex] = iFound;
	}
	iDPFLen = aDirectPlayFriends.length;
	for (iDPFIndex = 0; iDPFIndex < iDPFLen; iDPFIndex ++)
	{
		sStatus = ' (offline)';
		if (aStatus[iDPFIndex] == 1) sStatus = ' (might be online)';
		if (aStatus[iDPFIndex] == 2) sStatus = ' (online)';

		oMItem = oMenu.insertItemAt(iDPFIndex, aDirectPlayFriends[iDPFIndex][1] + ' - ' + aDirectPlayFriends[iDPFIndex][0] + sStatus, aDirectPlayFriends[iDPFIndex][0] + SEP_MESSAGES + aDirectPlayFriends[iDPFIndex][1]);
		oMItem.style.fontWeight = "bold";
	}
	ApplyColorScheme(oMenu);
}

function InitDirectPlayPONGGame()
{
	sDirectPlayInvitation = "";
	if (sNickName != "")
	{
		var oMenu = document.getElementById('mlmpdirectplayselect');
		var oPlayer = document.getElementById(sLastSelectedPlayerLIID);
		var sValue = '';
		if (oMenu.selectedItem) sValue = oMenu.selectedItem.value;
		if (sValue == '')
		{
			//Check for a typed value.
			var oBoxObject = oMenu.boxObject;
			var onsIBoxObject = oBoxObject.QueryInterface(Components.interfaces.nsIMenuBoxObject);
			sValue = onsIBoxObject.element.inputField.value;
			if (IsValidString(sValue) == false)
			{
				MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the Direct Play field.');
				onsIBoxObject.element.inputField.value = '';
				return;
			}
		}
		if (sValue == '')
		{
			if (oPlayer)
			{
				sValue = oPlayer.getAttribute('playerid');
				if (sValue != "") return DirectPlayInvite(sValue);
			}
		}
		if (sValue == '') return MessageBox('Please select a player from the list of online players, or select a friend from your list of friends.');

		sValue = sValue.toLowerCase();
		if (IsIPAddress(sValue) == true)
		{
			sValue = sValue + SEP_MESSAGES;
		}
		else
		{
			sValue = SEP_MESSAGES + sValue;
		}
		sDirectPlayInvitation = sValue;
		WriteData('dpfind' + SEP_MESSAGES + sDirectPlayInvitation);

		DisableMPControls(true);

		oStatusMessage.setText("Searching for selected player...");

		WaitForDirectPlayPIDs(0);
	}
	else
	{
		MessageBox('Please enter a nickname.');
	}
	return true;
}

function WaitForDirectPlayPIDs(iTries)
{
	var bResult = true;
	if (sDirectPlayInvitation != '')
	{
		var sStatus = oStatusMessage.getText();
		var sNewStatus = "";

		if (sStatus == "Searching for selected player...") sNewStatus = "Searching for selected player";
		if (sStatus == "Searching for selected player..") sNewStatus = "Searching for selected player...";
		if (sStatus == "Searching for selected player.") sNewStatus = "Searching for selected player..";
		if (sStatus == "Searching for selected player") sNewStatus = "Searching for selected player.";

		if (sNewStatus != "") oStatusMessage.setText(sNewStatus);

		iTries ++
		if (iTries > 10)
		{
			MessageBox('The player you selected does not appear to be online.\nPlease try again later, or refresh the list of games to see who else is online.');

			oStatusMessage.Close();
			DisableMPControls(false);
			SendNickName(); //Resets status.
		}
		else
		{
			setTimeout('WaitForDirectPlayPIDs(' + iTries.toSource() + ');', 400);
		}
	}
}

function SetDirectPlayPIDs(sData)
{
	var aData = sData.split(SEP_MESSAGES);
	var aPlayer;
	var aInvitation = sDirectPlayInvitation.split(SEP_MESSAGES);
	var iLen, iIndex;
	var bFoundExactMatch = false;

	iLen = aData.length;
	if (iLen > 1 && aInvitation.length == 2)
	{
		//Check for an exact match.
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			aPlayer = aData[iIndex].split(SEP_MESSAGE);
			if (aPlayer[1] == aInvitation[0] && aPlayer[2] == aInvitation[1]) bFoundExactMatch = true;
		}
	}
	if (iLen == 1 || bFoundExactMatch == true)
	{
        sDirectPlayInvitation = '';
		aPlayer = aData[0].split(SEP_MESSAGE);
		DirectPlayInvite(aPlayer[0]);
	}
	else
	{
		//Maybe make something for this later...
		MessageBox('Found more than 1 player matching the selected IPAddress and/or Nickname.');
	}
}

function DirectPlayInvite(sID)
{
	WriteData('dpinvite' + SEP_MESSAGES + sID + SEP_MESSAGES + sNickName + SEP_MESSAGES + EncodeSpeed(sSpeedCode) + SEP_MESSAGES + sBestOfCode);
	DisableMPControls(true);

	oStatusMessage.setText("Inviting player...");

	CheckForJoinedDirectPlayPlayer(0);
	var oBoxObject = document.getElementById('mlmpdirectplayselect').boxObject;
	var onsIBoxObject = oBoxObject.QueryInterface(Components.interfaces.nsIMenuBoxObject);
	onsIBoxObject.element.inputField.value = "";
	RemoveAllChildren(document.getElementById('mlmpdirectplayselect')); //Force clear of all...
}

function CheckForJoinedDirectPlayPlayer(iTries)
{
	var sStatus = oStatusMessage.getText();
	var sNewStatus = "";
	var bResult = true;

	if (sStatus == "Inviting player...") sNewStatus = "Inviting player";
	if (sStatus == "Inviting player..") sNewStatus = "Inviting player...";
	if (sStatus == "Inviting player.") sNewStatus = "Inviting player..";
	if (sStatus == "Inviting player") sNewStatus = "Inviting player.";

	if (sNewStatus != "") oStatusMessage.setText(sNewStatus);

	if (sOpponentID == "")
	{
		iTries ++
		if (iTries > 59) //Give the other onne some time to accpept...
		{
			MessageBox('It seems like the other player has gone offline, or has rejected your invitation.\nPlease try again later, or refresh the list of games to see who else is online.');

			oStatusMessage.Close();
			DisableMPControls(false);
		}
		else
		{
			WriteData('getjoin');
			setTimeout('CheckForJoinedDirectPlayPlayer(' + iTries.toSource() + ');', 1000);
		}
	}
}

function ReadDirectPlayInvitation(sData)
{
	var oMLMPBestOf = document.getElementById('mlmpbestofselect');
	var oMLMPSpeed = document.getElementById('mlmpspeedselect');
	var oMMPItemBestOf, oMMPItemSpeed;
	var aData = sData.split(SEP_MESSAGES);
	var sIDBestOf, sIDSpeed, sOppID, sOppNick;
	var bAccept = false;

	if (aData.length == 4)
	{
		sOppID = aData[0];
		sOppNick = aData[1];
		sIDSpeed = aData[2];
		sIDBestOf = aData[3];

		bAccept = confirm(sOppNick + ' has invited you for a game of PONG!\nThe game settings are:\nSpeed: ' + DecodeSpeed(sIDSpeed) + '\nPoints to win: ' + DecodeBestOf(sIDBestOf) + '\n\nPress [OK] to accept, or press [Cancel] to reject this invitation.');
		if (bAccept == true)
		{
			sOpponentID = sOppID;
			sOpponentNickName = sOppNick;

			oMMPItemBestOf = document.getElementById('mp' + sIDBestOf);
			sIDSpeed = GetSpeedID(sIDSpeed);
			oMMPItemSpeed = document.getElementById('mp' + sIDSpeed);

			oMLMPBestOf.selectedItem = oMMPItemBestOf;
			ProcessBestOfSelect(sIDBestOf);
			oMLMPSpeed.selectedItem = oMMPItemSpeed;
			ProcessSpeedSelect(sIDSpeed);

			DisableMPControls(true);

			WriteData('join' + SEP_MESSAGES + sOpponentID + SEP_MESSAGES + sNickName);

			oStatusMessage.setText("Waiting...");
			WaitForJoinAccepted(0);
		}
	}
}

function GetPongPlayers()
{
	ClearPlayersList();
	WriteData('getplayers' + SEP_MESSAGES);
}

function SetPlayers(sGames)
{
	var aGames;
	var aGame;
	var iGames = 0;
	var iIndex = 0;

	ClearPlayersList();

	aGames = sGames.split(SEP_MESSAGES);
	iGames = aGames.length
	for (iIndex = 0; iIndex < iGames; iIndex ++)
	{
		aGame = aGames[iIndex].split(SEP_MESSAGE);
		if (aGame.length == 2)
		{
			AddPongPlayer(aGame[0], aGame[1]);
		}
	}
}

function AddPongPlayer(sID, sNickName)
{
	if (sID == "" || sNickName == "") return false;
	if (sID == sPlayerID) return false;
	if(document.getElementById('id' + sID)) return false; //Duplicate...
	if(document.getElementsByAttribute('playerid', sID).length >= 1) return false; //Duplicate...
	var oPlayers = document.getElementById('vbpongplayers');
	var oPlayer = document.getElementById('clone_pongplayer').cloneNode(true);
	var sLabel = "";
	var sValue = "";

	sValue = sID;
	if (HexToInt(sValue.substr(2,2)) >= 240 && HexToInt(sValue.substr(4,2)) >= 240 && HexToInt(sValue.substr(5,2)) >= 240) sValue = "00000000"
	sLabel = sNickName;
              
	oPlayer.setAttribute('id', 'id' + sID);
	oPlayer.setAttribute('value', sNickName);
	oPlayer.setAttribute('playerid', sID);
	oPlayer.setAttribute('hidden', false);
	oPlayer.className = "";
	oPlayer.style.color = "rgb(" + HexToInt(sValue.substr(2,2)) + ", " + HexToInt(sValue.substr(4,2)) + ", " + HexToInt(sValue.substr(6,2)) + ")";
	
	oPlayers.appendChild(oPlayer);
}

function RemovePongPlayer(sID, sNickName)
{
	var oPlayers = document.getElementById('vbpongplayers');
	oPlayers.removeChild(document.getElementById('id' + sID));
	if(document.getElementById('id' + sID) || document.getElementsByAttribute('playerid', sID).length >= 1) return setTimeout("RemovePongPlayer(" + sID.toSource() + ", " + sNickName.toSource() + ");", 1);
}

function ProcessPlayerSelect(sID)
{
	if (sLastSelectedPlayerLIID != "") document.getElementById(sLastSelectedPlayerLIID).className = "";
	sLastSelectedPlayerLIID = sID;
	
	document.getElementById(sLastSelectedPlayerLIID).className = "player-active"
}

function ClearPlayersList()
{
	RemoveAllChildren(document.getElementById('vbpongplayers'));
}

function DisableMPControls(bEnable)
{
	document.getElementById('bdirectplayponggame').disabled = bEnable;
	document.getElementById('tbnickname').disabled = bEnable;
	document.getElementById('mlmpspeedselect').disabled = bEnable;
	document.getElementById('mlmpbestofselect').disabled = bEnable;
	document.getElementById('mlmpdirectplayselect').disabled = bEnable;
}

function SendChatStatus()
{
	if (iPONGHTTPConnection == 0 || iPONGHTTPConnection == -1) return setTimeout('SendChatStatus();', 100);
	WriteData('setchatstatus' + SEP_MESSAGES + sChatStatus);
}

function SendQuickChatMessage(sKey)
{
	if (sChatStatus == 'L') return SendLobbyQuickChatMessage(sKey);
	if (sChatStatus == 'G') return SendGameQuickChatMessage(sKey);
	return;
}

function SendLobbyChatMessage(sQuickMessage)
{
	var sMessage = sQuickMessage;
	if (sMessage == "") sMessage = document.getElementById('tblobbychat').value;
	if (sMessage == "") return;
	if (IsValidString(sMessage) == false && sQuickMessage == "")
	{
		MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the message.\nAs wel as the system login, logout and plays against messages.');
		document.getElementById('tblobbychat').value = "";
		document.getElementById('tblobbychat').focus();
		return;
	}
	WriteData('writelobbychat' + SEP_MESSAGES + sMessage);
	document.getElementById('tblobbychat').value = "";
	document.getElementById('tblobbychat').focus();
	return;
}

function SendLobbyQuickChatMessage(sKey)
{
	if (iPONGHTTPConnection == 0 || iPONGHTTPConnection == -1) return;
	SendLobbyChatMessage(GetPreferenceString("chattemplate" + sKey));
}

function CheckLobbyChatMessage()
{
	if (iPONGHTTPConnection == 1 && sChatStatus == 'L')	WriteData('getlobbychat' + SEP_MESSAGES);
	setTimeout('CheckLobbyChatMessage();', 3000);
}

function SetLobbyChatMessages(sMessages)
{
	var oGBMessages = document.getElementById('gbponglobbychat');
	var oItems;
	var oItem;
	var oDMessage;
	var aMessages;
	var aMessage;
	var aMessageParts;
	var sMessage = "";
	var sLabel = "";
	var sValue = "";
	var iMessages = 0;
	var iIndex = 0;
	var iSIndex, sSLen;
	var bHasSmiley;

	aMessages = sMessages.split(SEP_MESSAGES);
	iMessages = aMessages.length;
	iSLen = aSmileys.length;
	for (iIndex = 0; iIndex < iMessages; iIndex ++)
	{
		aMessage = aMessages[iIndex].split(SEP_MESSAGE);
		oItems = null;
		bHasSmiley = false;
		oItems = new Array;
		if (aMessage.length == 3)
		{
			if (aMessage[0] == sPlayerID && (aMessage[2] == MSG_LOGIN || aMessage[2] == MSG_LOGOUT))
			{
				//Don't write your own login/logout msg...
			}
			else
			{
				sValue = aMessage[0];
				if (HexToInt(sValue.substr(2,2)) >= 240 && HexToInt(sValue.substr(4,2)) >= 240 && HexToInt(sValue.substr(5,2)) >= 240) sValue = "00000000"

				oDMessage = document.createElement('description');
				oDMessage.style.color = "rgb(" + HexToInt(sValue.substr(2,2)) + ", " + HexToInt(sValue.substr(4,2)) + ", " + HexToInt(sValue.substr(6,2)) + ")";

				//Split up text/smileys.
				sMessage = aMessage[2];
				for (iSIndex = 0; iSIndex < iSLen; iSIndex ++)
				{
					sMessage = ReplaceAll(sMessage, aSmileys[iSIndex][0], "@class=" + aSmileys[iSIndex][1] + "@");
				}

				//Create elements
				aMessageParts = sMessage.split("@");
				iSLen = aMessageParts.length;
				for (iSIndex = 0; iSIndex < iSLen; iSIndex ++)
				{
					oItem = null;
					if (aMessageParts[iSIndex].substr(0, 6) == 'class=')
					{
						//Smiley
						oItem = document.createElement('image');
						oItem.setAttribute('id', 'smile');
						oItem.className = aMessageParts[iSIndex].substring(6, aMessageParts[iSIndex].length);
						oItems[iSIndex] = oItem;
						bHasSmiley = true;
					}
					else
					{
						//Text
						oItem = document.createTextNode(aMessageParts[iSIndex]);
						oItems[iSIndex] = oItem;
					}
				}

				//Add extra margin if no smiley is in this msg...
				if (bHasSmiley == false) oDMessage.style.marginTop = "5px";

				//Add elements to description element.
				oItem = document.createTextNode(aMessage[1] + ': ');
				oDMessage.appendChild(oItem);
				for (iSIndex = 0; iSIndex < iSLen; iSIndex ++)
				{
					oDMessage.appendChild(oItems[iSIndex]);
				}

				oGBMessages.insertBefore(oDMessage, oGBMessages.firstChild);
			}
			if (aMessage[0] != sPlayerID && aMessage[2] == MSG_LOGIN)
			{
				AddPongPlayer(aMessage[0], aMessage[1]);
				if (bAttentionOnLogin == true)
				{
					window.getAttention();
				}
			}
			if (aMessage[0] != sPlayerID && (aMessage[2] == MSG_LOGOUT || aMessage[2].substr(0, MSG_PLAYSAGAINST.length) == MSG_PLAYSAGAINST))
			{
				RemovePongPlayer(aMessage[0], aMessage[1]);
			}
		}
	}
}

function RemoveAllChildren(oGB)
{
	var oChild;
	var iIndex, iLen;

	iLen = oGB.childNodes.length - 1;

	for (iIndex = iLen; iIndex >= 0; iIndex --)
	{
		oChild = oGB.childNodes[iIndex];
		oGB.removeChild(oChild);
	}
}

function SendGameQuickChatMessage(sKey)
{
	if (iPONGHTTPConnection == 0 || iPONGHTTPConnection == -1) return;
	SendGameChatMessage(GetPreferenceString("chattemplate" + sKey));
}

function SetGameChatMessages(sMessages)
{
	var oGBMessages = document.getElementById('gbponggamechat');
	var oItems;
	var oItem;
	var oDMessage;
	var aMessages;
	var aMessage;
	var aMessageParts;
	var sMessage = "";
	var sLabel = "";
	var sValue = "";
	var iMessages = 0;
	var iIndex = 0;
	var iSIndex, sSLen;

	aMessages = sMessages.split(SEP_MESSAGES);
	iMessages = aMessages.length;
	iSLen = aSmileys.length;
	for (iIndex = 0; iIndex < iMessages; iIndex ++)
	{
		aMessage = aMessages[iIndex].split(SEP_MESSAGE);
		oItems = null;
		oItems = new Array;
		if (aMessage.length == 3)
		{
			sValue = aMessage[0];
			if (HexToInt(sValue.substr(2,2)) >= 240 && HexToInt(sValue.substr(4,2)) >= 240 && HexToInt(sValue.substr(5,2)) >= 240) sValue = "00000000"

			oDMessage = document.createElement('description');
			oDMessage.style.color = "rgb(" + HexToInt(sValue.substr(2,2)) + ", " + HexToInt(sValue.substr(4,2)) + ", " + HexToInt(sValue.substr(6,2)) + ")";

			//Split up text/smileys.
			sMessage = aMessage[2];
			for (iSIndex = 0; iSIndex < iSLen; iSIndex ++)
			{
				sMessage = ReplaceAll(sMessage, aSmileys[iSIndex][0], "@class=" + aSmileys[iSIndex][1] + "@");
			}

			//Create elements
			aMessageParts = sMessage.split("@");
			iSLen = aMessageParts.length;
			for (iSIndex = 0; iSIndex < iSLen; iSIndex ++)
			{
				oItem = null;
				if (aMessageParts[iSIndex].substr(0, 6) == 'class=')
				{
					//Smiley
					oItem = document.createElement('image');
					oItem.setAttribute('id', 'smile');
					oItem.className = aMessageParts[iSIndex].substring(6, aMessageParts[iSIndex].length);
					oItems[iSIndex] = oItem;
				}
				else
				{
					//Text
					oItem = document.createTextNode(aMessageParts[iSIndex]);
					oItems[iSIndex] = oItem;
				}
			}

			//Add elements to description element.
			oItem = document.createTextNode(aMessage[1] + ': ');
			oDMessage.appendChild(oItem);
			for (iSIndex = 0; iSIndex < iSLen; iSIndex ++)
			{
				oDMessage.appendChild(oItems[iSIndex]);
			}
			oGBMessages.insertBefore(oDMessage, oGBMessages.firstChild);
		}
	}
}

function ProcessConnectionTestResult(sResult)
{
	var aData = sResult.split(SEP_MESSAGES);
	
	iConnectionTestResult += parseInt(aData[1]);

	if (iConnectionTestResult == 2) MessageBox('Connection test succeeded...'); //All ok.
	if (iConnectionTestResult == -2) MessageBox('An error occured while testing the connection.\nDid not receive an incomming connection.\n(Might be a problem in your firewall settings, you need to have port ' + iTimedPort + '-' + iLoopPort + ' opened.)');
	
	if (iConnectionTestResult > 1 || iConnectionTestResult < -1) CloseServerSockets();
}

function InsertLobbyChatSmiley(sSmiley)
{
	var oTB = document.getElementById('tblobbychat');
	InsertChatSmiley(oTB, sSmiley);
}

function InsertGameChatSmiley(sSmiley)
{
	var oTB = document.getElementById('tbgamechat');
	InsertChatSmiley(oTB, sSmiley);
}

function InsertChatSmiley(oTB, sSmiley)
{
	var sValue = oTB.value;
	var sLeft = "";
	var sRight = "";
	var iPos = oTB.selectionEnd;

	if (sValue != "")
	{
		sLeft = sValue.substr(0, iPos);
		if (sLeft.charAt(sLeft.length - 1) != " ") sLeft += " ";
		sRight =  sValue.substring(iPos, sValue.length);
		if (sRight.charAt(0) != " ") sRight = " " + sRight;
	}
	oTB.value = sLeft + sSmiley + sRight;
}

function SetSmileyPopupIsShowing(bSet)
{
	bSmileyPopupIsShowing = bSet;
}

//Decode/Encode stuff cause we want to sent all socket data as small as possible...
function DecodeSpeed(sCode)
{
	if (sCode == 'N') return 'Normal speed'
	if (sCode == 'M') return 'Medium speed'
	if (sCode == 'F') return 'Fast speed'
	if (sCode == 'I') return 'Insane speed'
	if (sCode == 'S') return 'Super Insane speed'
}

function GetSpeedID(sCode)
{
	if (sCode == 'N') return 'normal'
	if (sCode == 'M') return 'medium'
	if (sCode == 'F') return 'fast'
	if (sCode == 'I') return 'insane'
	if (sCode == 'S') return 'superinsane'
}

function EncodeSpeed(sLabel)
{
	return sLabel.substr(0, 1).toUpperCase();
}

function DecodeBestOf(sCode)
{
	return sCode.substr(1, sCode.length - 1) + ' points to win';
}

function ReplaceAll(sString, sFind, sReplace)
{
  while (sString.indexOf(sFind) >= 0)
  {
    sString = sString.replace(sFind, sReplace);
  }
  return sString;
}

function HexToInt(sHexString)
{
	return parseInt(sHexString, 16);
}

function Sleep(iTimeMS)
{
	var iStart = parseInt(new Date().getTime());
	var iNow, iDiv;
	while (iDiv < iTimeMS)
	{
		iNow = parseInt(new Date().getTime());
		iDiv = iNow - iStart;
	}
}

function WriteDebugMessage(aMsg)
{
	var oConsole = C.classes["@mozilla.org/consoleservice;1"].getService(C.interfaces["nsIConsoleService"]);
	oConsole.logStringMessage(aMsg);
}

function MessageBox(sText)
{
	alert(sText + '\nVisit http://forum.captaincaveman.nl/ for more information and help');
}

function IsIPAddress(sValue)
{
	var aValue = sValue.split('.');
	var iIndex, iLen;
	var bRet = false;

	iLen = aValue.length;
	if (iLen == 4)
	{
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (parseInt(aValue[iIndex]) >= 0) bRet = true;
			if (bRet == false) return false;
		}
	}
	return bRet;
}

function IsValidString(sValue)
{
	if (sValue.indexOf(SEP_COMMANDS) >= 0 || sValue.indexOf(SEP_COMMAND) >= 0 || sValue.indexOf(SEP_MESSAGES) >= 0 || sValue.indexOf(SEP_MESSAGE) >= 0 || HasEscapeChar(sValue) == true) return false;
	if (sValue.substr(0, MSG_PLAYSAGAINST.length) == MSG_PLAYSAGAINST) return false;
	if (sValue == MSG_LOGIN || sValue == MSG_LOGOUT) return false;
	return true;
}

function HasEscapeChar(sValue)
{
	var iIndex, iLen;

	iLen = sValue.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (sValue.charCodeAt(iIndex) == 92 && (sValue.charCodeAt(iIndex + 1) == 110 || sValue.charCodeAt(iIndex + 1) == 78)) return true;
	}
	return false;
}

function GetIPAddress()
{
	var dns = Components.classes["@mozilla.org/network/dns-service;1"].getService(Components.interfaces.nsIDNSService);
	return dns.resolve(dns.myHostName, 0).getNextAddrAsString();
}

function SortNickNames(a1, a2)
{
	if (a1[1] < a2[1]) return -1;
	return 1;
}

function GetStatusMessage()
{
	var StatusMessage = document.getElementById("statusmessage");
	if (!StatusMessage)
	{
		StatusMessage = document.createElement("description");
		StatusMessage.id = "statusmessage";
		StatusMessage.resize = function(iPrevTextLen, iCurTextLen)
		{
			this.top = 100;

			if (Math.abs(iPrevTextLen - iCurTextLen) >= 3)
			{
				this.width = (this.getText().length * 10);
				if (iCurTextLen < 20)
				{
					this.width = parseInt(this.width) + 50;
				}
				this.left = (WINDOW_RIGHT / 2) - (this.width / 2);
			}
		}
		StatusMessage.setText = function(sText, closeTimeout)
		{
			var iLen = this.getText().length;

			if (sText == "") return this.Close();
			this.setAttribute('value', sText);
			this.style.display = "block";
			this.resize(iLen, sText.length);
			if (closeTimeout) this.delayClose(closeTimeout);
			return;
		}
		StatusMessage.getText = function()
		{
			return this.getAttribute('value');
		}
		StatusMessage.Close  = function()
		{
			this.style.display = "none";
		}
		StatusMessage.delayClose = function(timeout)
		{
			window.statusmessage = this;
			window.setTimeout("window.statusmessage.style.display = 'none';", timeout);
		}
		StatusMessage.style.display = "none";
		document.getElementById('stack_main').appendChild(StatusMessage);
	}
	return StatusMessage;
}

function GetVersion()
{
    try
    {
    	var oEM = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
      	if (oEM.getItemForID) {return oEM.getItemForID("{1368F36C-0370-419a-A408-28F94FD35974}").version;}
    	else {return oEM.getItemList("{1368F36C-0370-419a-A408-28F94FD35974}", null, {})[0].version;}
    }
    catch (e) {return "2.3"}
}

//In-game connection (direct connection to the other player.
function OpenInGameConnection()
{
	bIsTestGame = false;
	if (sNickName == 'Captain Caveman' && sOpponentNickName == 'Captain Caveman') bIsTestGame = true;
	//Open servers...
	OpenServerSockets();

	//Open In-game clients...
	oPongTimedGameClient = new Socket;
	oPongLoopGameClient = new Socket;

	if (bIsTestGame == false || bStartedGame == true)
	{
		oPongTimedGameClient.open(sOpponentIPAddress, iTimedPort);
	}
	else
	{
		oPongTimedGameClient.open(sOpponentIPAddress, 10995);
	}

	if (bIsTestGame == false || bStartedGame == true)
	{
		oPongLoopGameClient.open(sOpponentIPAddress, iLoopPort);
	}
	else
	{
		oPongLoopGameClient.open(sOpponentIPAddress, 10996);
	}

	oStatusMessage.setText('Connecting to opponent...');
	return setTimeout('TestInGameConnection(0);', 2000);
}

function TestInGameConnection(iTries)
{
	ReadBlockingInGameData();
	if ((oPongTimedGameClient.isAlive() == true || oPongLoopGameClient.isAlive() == true) && iTries < 9)
	{
		if (oPongTimedGameClient.isAlive() == true) WriteInGameData('igconnected' + SEP_COMMAND + 'NBT');
		if (oPongLoopGameClient.isAlive() == true) WriteBlockingInGameData('igconnected' + SEP_COMMAND + 'BT');

		bInGameConnected = true;
		if (bInGameConnected == true && bNonBlockingConnected == true && bBlockingConnected == true)
		{
			oStatusMessage.setText("Enjoy!", 500);
			ClearPlayersList();
			NewGame(1);
		}
		else
		{
			iTries ++;
			return setTimeout('TestInGameConnection(' + iTries.toSource() + ');', 1000);
		}
	}
	else
	{
		iTries ++;
		if (iTries < 9) return setTimeout('TestInGameConnection(' + iTries.toSource() + ');', 1000);
		if (bInGameConnected == true && (bNonBlockingConnected == false || bBlockingConnected == false)) MessageBox('An error occured while connecting to your opponent.\nCould not create an outgoing connection.\n(Might be a problem in your firewall settings, both players need to have port ' + iTimedPort + '-' + iLoopPort + ' opened.)');
		if (bInGameConnected == false && (bNonBlockingConnected == true || bBlockingConnected == true)) MessageBox('An error occured while connecting to your opponent.\nDid not receive an incomming connection.\n(Might be a problem in your firewall settings, both players need to have port ' + iTimedPort + '-' + iLoopPort + ' opened.)');
		if (bInGameConnected == false && (bNonBlockingConnected == false || bBlockingConnected == false)) MessageBox('An error occured while connecting to your opponent.\nDid not receive an incoming or create an outgoing connection.\n(Might be a problem in your firewall settings, both players need to have port ' + iTimedPort + '-' + iLoopPort + ' opened.)');
		oStatusMessage.Close();
		sOpponentID = "";
		sDirectPlayInvitation = "";
		sOpponentNickName = "";
		sOpponentIPAddress = "";

		DisableMPControls(false);
		bInGameConnected = false;
		bNonBlockingConnected = false;
		bBlockingConnected = false;

		ClearPlayersList();
		GetPongPlayers();
	}
	return true;
}

function SetInGameConnected(sData)
{
	if (sData == 'NBT')
	{
		bNonBlockingConnected = true;
	}
	if (sData == 'BT')
	{
		bBlockingConnected = true;
	}
}

function OpenServerSockets()
{
	oTimedServerSocket = Components.classes["@mozilla.org/network/server-socket;1"].createInstance(Components.interfaces.nsIServerSocket);
	oLoopServerSocket = Components.classes["@mozilla.org/network/server-socket;1"].createInstance(Components.interfaces.nsIServerSocket);

	if (bIsTestGame == false || bStartedGame == false)
	{
	    oTimedServerSocket.init(iTimedPort,false,-1);
	}
	else
	{
	    oTimedServerSocket.init(10995,false,-1);
	}
    ServerSocketListener.iTimedPort = iTimedPort;
    oTimedServerSocket.asyncListen(ServerSocketListener);

	if (bIsTestGame == false || bStartedGame == false)
	{
		oLoopServerSocket.init(iLoopPort,false,-1);
	}
	else
	{
		oLoopServerSocket.init(10996,false,-1);
	}
    ServerSocketListener.iTimedPort = iTimedPort;
    oLoopServerSocket.asyncListen(ServerSocketListener);
}

function CloseServerSockets()
{
	if (oTimedServerSocket) oTimedServerSocket.close();
	if (oLoopServerSocket) oLoopServerSocket.close();
}

function CloseInGameConnection()
{
	if (oPongTimedGameClient != null)
	{
		if (oPongTimedGameClient.isAlive() == true)
		{
			sStatus = "Q";
			bExchangeData = true;
			ExchangePONGData(true, true);
			bExchangeData = false;
			setTimeout('CloseInGameConnection();', 100);
		}
		CloseServerSockets();
		oPongTimedGameClient.close();
		oPongTimedGameClient = null;
		if (oPongIncomingTimedGameClient)
		{
			oPongIncomingTimedGameClient.close()
			oPongIncomingTimedGameClient = null;
		}
		if (oPongIncomingLoopGameClient)
		{
			oPongIncomingLoopGameClient.close()
			oPongIncomingLoopGameClient = null;
		}
		setTimeout('CloseInGameConnection();', 500);
	}
	else
	{
		ResetMultiPlayer();
		if (bReturnToLobby == true) setTimeout('InitStart(); InitMultiPlayer();', 1000);
	}
}

function WriteInGameData(sData)
{
	sData = SEP_COMMANDS + sData;
	if(oPongTimedGameClient && oPongTimedGameClient.isAlive()) return oPongTimedGameClient.write(sData);
}

function ReadInGameData()
{
	sData = "";
	iBytes = 0;

	if(oPongTimedGameClient && oPongTimedGameClient.isAlive())
	{
		iBytes = oPongTimedGameClient.available();
		if (iBytes > 0) sData = oPongTimedGameClient.read(iBytes);
		ProcessReceivedPONGData(sData, false);
	}
}

function WriteBlockingInGameData(sData)
{
	sData = SEP_COMMANDS + sData;
	if(oPongLoopGameClient && oPongLoopGameClient.isAlive())
	{
		var iResult = oPongLoopGameClient.write(sData);
		return true;
	}
}

function ReadBlockingInGameData()
{
	sData = "";
	iBytes = 0;

	if(oPongLoopGameClient && oPongLoopGameClient.isAlive())
	{
		iBytes = oPongLoopGameClient.available();
		if (iBytes > 0) sData = oPongLoopGameClient.read(iBytes);
		ProcessReceivedPONGData(sData, false);
	}
}

function ExchangePONGData(bOnce, bBlocking)
{
	if (bExchangeData == true)
	{
		bExchangeData = false;
		if (bBlocking == false)
		{
			//Maybe it will arive, maybe it wont...
			if (bStartedGame == true) WriteInGameData('ed' + SEP_COMMAND + oPlayer.top + SEP_MESSAGES + sStatus + SEP_MESSAGES + iMPBallXPos + SEP_MESSAGES + iMPBallYPos + SEP_MESSAGES + iMPBallVX + SEP_MESSAGES + iMPBallVY);
			if (bStartedGame == false) WriteInGameData('ed' + SEP_COMMAND + oComputer.top + SEP_MESSAGES + sStatus + SEP_MESSAGES + iMPBallXPos + SEP_MESSAGES + iMPBallYPos + SEP_MESSAGES + iMPBallVX + SEP_MESSAGES + iMPBallVY);
		}
		else
		{
			//Process will halt until it has arived (has been sent...).
			if (bStartedGame == true) WriteBlockingInGameData('ed' + SEP_COMMAND + oPlayer.top + SEP_MESSAGES + sStatus + SEP_MESSAGES + iMPBallXPos + SEP_MESSAGES + iMPBallYPos + SEP_MESSAGES + iMPBallVX + SEP_MESSAGES + iMPBallVY);
			if (bStartedGame == false) WriteBlockingInGameData('ed' + SEP_COMMAND + oComputer.top + SEP_MESSAGES + sStatus + SEP_MESSAGES + iMPBallXPos + SEP_MESSAGES + iMPBallYPos + SEP_MESSAGES + iMPBallVX + SEP_MESSAGES + iMPBallVY);
		}
		bExchangeData = true;
	}
	if (bOnce == false) ExchangeDataID = setTimeout('ExchangePONGData(false, false);', EXCHANGE_DATA_SPEED);
}

function SetPONGData(sData)
{
	var aData;

	bDataIsCurrent = false;
	aData = sData.split(SEP_MESSAGES);
	if (aData.length == 6)
	{
		bDataIsCurrent = true;
		var iNow = parseInt(new Date().getTime());
		iLagTime = iNow - iLastMPRead;
		if (iLagTime > LAG_TIME_ALERT) iLagAlertCount ++;
		else iLagAlertCount --;

		if (iLagAlertCount >= 3) document.getElementById('lagalert').style.display = "block";
		if (iLagAlertCount <= 0) document.getElementById('lagalert').style.display = "none";

		iLastMPRead = parseInt(new Date().getTime());

		iOpponentYPos = parseInt(aData[0]);

		if (aData[1] != sOpponentStatus)
		{
			sOpponentStatus = aData[1];

			if (sOpponentStatus == "P" && bPaused == false) PauseGame(false);
			if (sOpponentStatus == "A" && bPaused == true && bPlayerCanResumeGame == false) ResumeGame();

			if (sOpponentStatus == "Q" && sOpponentNickName != "" && bQuiting == false && (bHandledScore == false || bWaitToStart == true || iPlayerScore == iBestOf || iComputerScore == iBestOf))
			{
				MessageBox(sOpponentNickName + ' has quit the game...');
				return QuitGame(false);
			}

			if (bHandledScore == true)
			{
				if (sOpponentStatus == "A" && bStartedGame == true && bPlayer2Starts == true && bWaitToStart == true) StopWaitToStart();
				if (sOpponentStatus == "A" && bStartedGame == false && bPlayer2Starts == false && bWaitToStart == true) StopWaitToStart();
			}
		}

		if (bControlsGame == false)
		{
			if (aData[2] != "" && aData[3] != "" && aData[4] != "" && aData[5] != "")
			{
				iMPBallXPos = parseInt(aData[2]);
				iMPBallYPos = parseInt(aData[3]);
				iMPBallVX = parseInt(aData[4]);
				iMPBallVY = parseInt(aData[5]);
			}
		}
	}
	return true;
}

function SendGameChatMessage(sQuickMessage)
{
	var sMessage = sQuickMessage;
	if (sMessage == "") sMessage = document.getElementById('tbgamechat').value;
	if (sMessage == "") return;
	if (IsValidString(sMessage) == false && sQuickMessage == "")
	{
		MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the message.\nAs wel as the system login, logout and plays against messages.');
		document.getElementById('tbgamechat').value = "";
		document.getElementById('tbgamechat').focus();
		return;
	}
	WriteInGameData('getgamechat' + SEP_COMMAND + sPlayerID + SEP_MESSAGE + sNickName + SEP_MESSAGE + sMessage);
	SetGameChatMessages(sPlayerID + SEP_MESSAGE + sNickName + SEP_MESSAGE + sMessage);
	document.getElementById('tbgamechat').value = "";
	document.getElementById('nofocusforgamechatedit').focus();
}

function SendScored()
{
	if (sWhoScored == "1" || sWhoScored == "2") WriteBlockingInGameData('score' + SEP_COMMAND + sWhoScored);
	bHandledScore = false;
}

function CheckScored(sData)
{
	sWhoScored = sData;
	if (bControlsGame == false)
	{
		if (sWhoScored == '2')
		{
			PlaySound('playerscore');
			StartNextLevel(true);
			bHandledScore = true;
		}
		if (sWhoScored == '1')
		{
			PlaySound('computerscore');
			StartNextLevel(false);
			bHandledScore = true;
		}
		if (sWhoScored == "1" || sWhoScored == "2") WriteBlockingInGameData('score' + SEP_COMMAND + sWhoScored);
	}
	else
	{
		if (sWhoScored == "1" || sWhoScored == "2")
		{
			bHandledScore = true;
		}
	}
	if (bHandledScore == true)
	{
		sWhoScored = "";
	}
}
function SendControl(sOpponentControlsTorF)
{
	WriteBlockingInGameData('control' + SEP_COMMAND + sOpponentControlsTorF);
}

function CheckControl(sData)
{
	if (sData == 'T' && bControlsGame == false)
	{
		bControlsGame = true;
		WriteBlockingInGameData('control' + SEP_COMMAND + 'F');
	}
	if (sData == 'F' && bControlsGame == true)
	{
		bControlsGame = false;
		WriteBlockingInGameData('control' + SEP_COMMAND + 'T');
	}
}
