// Every time a new browser window is made PONGOverlayInit will be called
this.bToolbarQuestionAsked = false;
window.addEventListener("load",PONGOverlayPreInit,true);

function PONGOverlayPreInit()
{
	if (!this.oPONGTrans) setTimeout('PONGOverlayInit();', 500);
}

function PONGOverlayInit()
{
	this.oPONGTrans = new PONGTranslator();
	this.bAllowReservedNick = false;

	InitPONGPreferences();
	
	if (CheckPreferenceUserValue("allowreservednickname")) this.bAllowReservedNick = GetPreferenceBool("allowreservednickname");

	if (!CheckPreferenceUserValue("shortcutmodifier")) SetPreferenceString("shortcutmodifier", "control shift");
	if (!CheckPreferenceUserValue("shortcutkey")) SetPreferenceString("shortcutkey", "P");
	
	var oFFKey = document.getElementById('ff-pong-key');
	var oMozKey = document.getElementById('moz-pong-key');
	
	if (oFFKey)
	{
		oFFKey.removeAttribute('modifiers');
		oFFKey.removeAttribute('key');

		oFFKey.setAttribute("modifiers",GetPreferenceString("shortcutmodifier"));
		oFFKey.setAttribute("key",GetPreferenceString("shortcutkey"));
	}
	if (oMozKey)
	{
		oMozKey.removeAttribute('modifiers');
		oMozKey.removeAttribute('key');

		oMozKey.setAttribute("modifiers",GetPreferenceString("shortcutmodifier"));
		oMozKey.setAttribute("key",GetPreferenceString("shortcutkey"));
	}

	if (this.bToolbarQuestionAsked == false)
	{
		this.bToolbarQuestionAsked = true;
		setTimeout('PONGAddToolbar();', 500);
	}
	var oTBButton = document.getElementById('tbtnCavemanPONG');
	var oMenuItem = document.getElementById('miCavemanPONG');
	this.HoverTimerID = null;
	if (oTBButton)
	{
		oTBButton.addEventListener('mouseover', PONGToolbarButtonHoverStart, false);
		oTBButton.addEventListener('mouseout', PONGToolbarButtonHoverStop, false);
	}
	if (oMenuItem)
	{
		oMenuItem.addEventListener('mouseover', PONGToolbarButtonHoverStart, false);
		oMenuItem.addEventListener('mouseout', PONGToolbarButtonHoverStop, false);
	}
	this.iHoverTime = 0;
}

function PONGAddToolbar()
{
	//Check if the user wants to automaticly add the toolbar button.
	if (!CheckPreferenceUserValue("checkaddtoolbarbutton")) SetPreferenceBool("checkaddtoolbarbutton", true);
	var sLocation = content.document.location.href;	

	var oNavBar = document.getElementById("nav-bar");
	if (oNavBar && oNavBar.currentSet)
	{
		var bCheck = GetPreferenceBool("checkaddtoolbarbutton") && (!document.getElementById('tbtnCavemanPONG'));

		if (bCheck)
		{
			var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
			var checkResult = {};

			var bAddButton = promptService.confirmCheck(window,this.oPONGTrans.GetString("pong-alert-toolbar-title"), this.oPONGTrans.GetString("pong-alert-toolbar-question"), this.oPONGTrans.GetString("pong-alert-toolbar-dontshowagain"), checkResult);
			if (checkResult.value) bCheck = false;
			
			if (bAddButton == true)
			{
				var sNewSet = oNavBar.currentSet + ",tbtnCavemanPONG";
				oNavBar.currentSet = sNewSet;
				oNavBar.setAttribute("currentset", sNewSet );
				document.persist("nav-bar", "currentset");
				var oChromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
				oChromeRegistry.reloadChrome();
				promptService.alert(window, this.oPONGTrans.GetString("pong-alert-toolbar-title"), this.oPONGTrans.GetString("pong-alert-toolbar-success"));
				content.document.location.href = sLocation;
			}
			SetPreferenceBool("checkaddtoolbarbutton", bCheck);
		}
	}
}

function PONGToolbarButtonHoverStart()
{
	this.HoverTimerID = setInterval('PONGToolbarButtonHover();', 500);
}

function PONGToolbarButtonHoverStop()
{
	clearInterval(this.HoverTimerID);
}

function PONGToolbarButtonHover()
{
	var oTBButton = document.getElementById('tbtnCavemanPONG');
	var iHoverAttribute = parseInt(oTBButton.getAttribute('hovertime')) + 1;
	if (iHoverAttribute == 6) iHoverAttribute = 1;
	oTBButton.setAttribute('hovertime', iHoverAttribute.toString());

	var oMenuItem = document.getElementById('miCavemanPONG');
	iHoverAttribute = parseInt(oMenuItem.getAttribute('hovertime')) + 1;
	if (iHoverAttribute == 6) iHoverAttribute = 1;
	oMenuItem.setAttribute('hovertime', iHoverAttribute.toString());
}

function PlayPONG() {
	if (this.bAllowReservedNick == false)
	{
		window.openDialog("chrome://pong/content/pong.xul", "pong-window", "chrome,resizable=no,dialog=no,width=450,height=450");
	}
	else
	{
		window.openDialog("chrome://pong/content/pong.xul", "_blank", "chrome,resizable=no,dialog=no,width=450,height=450");
	}
}
