var oTestPongNonBlockingGameClient = null;
var oTestPongBlockingGameClient = null;
var oTestPongIncomingNBGameClient = null;
var oTestPongIncomingBGameClient = null;
var oTestNonBlockingServerSocket = null;
var oTestBlockingServerSocket = null;

var iTestTimedPort = 10997;
var iTestLoopPort = 10998;

var TestServerSocketListener =
{
	onSocketAccepted : function(socket, transport)
	{
		if (socket.port == iTestTimedPort)
		{
			oTestPongIncomingNBGameClient = new Socket;
			if (oTestPongIncomingNBGameClient)
			{
				oTestPongIncomingNBGameClient.create(transport);
				oTestPongIncomingNBGameClient.async(oTestPongClientObserver);
			}
		}
		else
		{
			oTestPongIncomingBGameClient = new Socket;
			if (oTestPongIncomingBGameClient)
			{
				oTestPongIncomingBGameClient.create(transport);
				oTestPongIncomingBGameClient.async(oTestPongClientObserver);
			}
		}
	},
	onStopListening : function(socket, status){}
};

var oTestPongClientObserver =
{
	streamStarted: function(socketContext) {},
	streamStopped: function(socketContext, status) {},
	receiveData: function(data) {TestProcessReceivedPONGData(data);}
};

var sTestIPAddress = "";

var bTestInGameConnected = false;
var bTestNonBlockingConnected = false;
var bTestBlockingConnected = false;
var bTestResultsNotified = false;

function InitConnectionTest()
{
	oTestPongNonBlockingGameClient = null;
	oTestPongBlockingGameClient = null;
	oTestPongIncomingNBGameClient = null;
	oTestPongIncomingBGameClient = null;
	oTestNonBlockingServerSocket = null;
	oTestBlockingServerSocket = null;

	bTestResultsNotified = false;
	bTestInGameConnected = false;
	bTestNonBlockingConnected = false;
	bTestBlockingConnected = false;
	iTestTimedPort = GetPreferenceInt("timedport");
	iTestLoopPort = GetPreferenceInt("loopport");
	
	sTestIPAddress = GetIPAddress();
	TestOpenInGameConnection();
}

function TestOpenInGameConnection()
{
	//Open servers...
	TestOpenServerSockets();
	
	//Open In-game clients...
	oTestPongNonBlockingGameClient = new Socket;
	oTestPongBlockingGameClient = new Socket;

	oTestPongNonBlockingGameClient.open(sTestIPAddress, iTestTimedPort);
	oTestPongBlockingGameClient.open(sTestIPAddress, iTestLoopPort);

	return setTimeout('TestTestInGameConnection(0);', 2000);
}

function TestTestInGameConnection(iTries)
{
	var oObService;
	var bLameAnd = false;
	
	if (iTries == 0 || iTries == 1 || iTries == 2 || iTries == 3 || iTries == 4) bLameAnd = true;
	if (bLameAnd == true)
	{
		if (oTestPongNonBlockingGameClient.isAlive() == true || oTestPongBlockingGameClient.isAlive() == true) bLameAnd = true;
	}
	else {bLameAnd = false}
	if (bLameAnd == true)
	{
		if (oTestPongNonBlockingGameClient.isAlive() == true) TestWriteInGameData('igconnected' + SEP_COMMAND + 'NBT');
		if (oTestPongBlockingGameClient.isAlive() == true) TestWriteBlockingInGameData('igconnected' + SEP_COMMAND + 'BT');
		
		bTestInGameConnected = true;
		bLameAnd = false;
		if (bTestInGameConnected == true)
		{
			if (bTestNonBlockingConnected == true)
			{
				if (bTestBlockingConnected == true) bLameAnd = true;
			}
		}
		if (bLameAnd == true)
		{
			if (!bTestResultsNotified)
			{
				bTestResultsNotified = true;
				oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				oObService.notifyObservers(window, "connectiontest", 1);
			}

			TestCloseInGameConnection();
		}
		else
		{
			iTries ++;
			return setTimeout('TestTestInGameConnection(' + iTries.toSource() + ');', 1000);			
		}
	}
	else
	{
		iTries ++;
		var iTestResult = 0;
		if (iTries == 0 || iTries == 1 || iTries == 2 || iTries == 3 || iTries == 4) return setTimeout('TestTestInGameConnection(' + iTries.toSource() + ');', 1000);
		if (bTestInGameConnected == true)
		{
			if ((bTestNonBlockingConnected == false || bTestBlockingConnected == false)) iTestResult = -1;
		}
		else
		{
			if ((bTestNonBlockingConnected == true || bTestBlockingConnected == true))  iTestResult = -2;
			if ((bTestNonBlockingConnected == false || bTestBlockingConnected == false))  iTestResult = -3;
		}
			if (!bTestResultsNotified)
			{
				bTestResultsNotified = true;
				oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
				oObService.notifyObservers(window, "connectiontest", iTestResult);
			}
		bTestInGameConnected = false;
		bTestNonBlockingConnected = false;
		bTestBlockingConnected = false;
		TestCloseInGameConnection();
	}
	return true;
}

function TestSetInGameConnected(sData)
{
	if (sData == 'NBT')
	{
		bTestNonBlockingConnected = true;
	}
	if (sData == 'BT')
	{
		bTestBlockingConnected = true;
	}
}

function TestOpenServerSockets()
{
	oTestNonBlockingServerSocket = Components.classes["@mozilla.org/network/server-socket;1"].createInstance(Components.interfaces.nsIServerSocket);
	oTestBlockingServerSocket = Components.classes["@mozilla.org/network/server-socket;1"].createInstance(Components.interfaces.nsIServerSocket);
	
    oTestNonBlockingServerSocket.init(iTestTimedPort,false,-1);
    oTestNonBlockingServerSocket.asyncListen(TestServerSocketListener);
	
	oTestBlockingServerSocket.init(iTestLoopPort,false,-1);
    oTestBlockingServerSocket.asyncListen(TestServerSocketListener);
}

function TestCloseServerSockets()
{
	if (oTestNonBlockingServerSocket) oTestNonBlockingServerSocket.close();
	if (oTestBlockingServerSocket) oTestBlockingServerSocket.close();
	oTestNonBlockingServerSocket = null;
	oTestBlockingServerSocket = null;	
}

function TestCloseInGameConnection()
{
	if (oTestPongNonBlockingGameClient != null)
	{
		TestCloseServerSockets();
		oTestPongNonBlockingGameClient.close();
		oTestPongNonBlockingGameClient = null;
		if (oTestPongIncomingNBGameClient)
		{
			oTestPongIncomingNBGameClient.close()
			oTestPongIncomingNBGameClient = null;
		}
		if (oTestPongIncomingBGameClient)
		{
			oTestPongIncomingBGameClient.close()
			oTestPongIncomingBGameClient = null;
		}
		oTestPongNonBlockingGameClient = null;
		oTestPongBlockingGameClient = null;
		oTestPongIncomingNBGameClient = null;
		oTestPongIncomingBGameClient = null;
		setTimeout('TestCloseInGameConnection();', 500);
	}
	bTestInGameConnected = false;
	bTestNonBlockingConnected = false;
	bTestBlockingConnected = false;
}

function TestWriteInGameData(sData)
{
	sData = SEP_COMMANDS + sData;
	if(oTestPongNonBlockingGameClient.isAlive()) return oTestPongNonBlockingGameClient.write(sData);
}


function TestWriteBlockingInGameData(sData)
{
	sData = SEP_COMMANDS + sData;
	if(oTestPongBlockingGameClient.isAlive())
	{
		var iResult = oTestPongBlockingGameClient.write(sData);
		return true;
	}
}

function TestProcessReceivedPONGData(Data)
{
	var iIndex, iLen, iPos;
	var sCommand = "";
	var sData = "";
	var aData;
	
	aData = Data.split(SEP_COMMANDS);
	iLen = aData.length;
	if (iLen >= 1)
	{
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (aData[iIndex] != "")
			{
				iPos = aData[iIndex].indexOf(SEP_COMMAND);
				sCommand = aData[iIndex].substr(0, iPos);
				sData = aData[iIndex].substring(iPos + 1, aData[iIndex].length);
				if (sCommand == 'igconnected') TestSetInGameConnected(sData);
			}
		}
	}
}
